var basePanel;
var editorWindow;
var selectedItem;
var columnDef;
var selectedId;
var saveCallback;
var saveSingleCallback;
var deleteCallback;

var multiSelectedItem = {};
var multiSelectedId = {};
var multiPassiveColumn = {};
var multiEditorWindow = {};
var multiPanelArray={};

Ext.Date.dayNames = [ 'Sonntag', 'Montag', 'Dienstag', 'Mittwoch',
          			'Donnerstag', 'Freitag', 'Samstag' ];
Ext.Date.MonthNames = [ 'Januar', 'Februar', 'M&auml;rz', 'April', 'Mai',
		'Juni', 'Juli', 'August', 'September', 'Oktober', 'November',
		'Dezember' ];


function pad(i) { return i < 10 ? '0' + i : i; }

// v2 approved
function showWaitDialog(message) {
	Ext.MessageBox.show({
		msg : message,
		progressText : 'Initializing...',
		width : 300,
		progress : true,
		closable : false
	});
}

// v2 approved
function hideWaitDialog() {
	Ext.MessageBox.hide();
}

// v2 approved
function updateWaitDialog(percentage, message) {
	Ext.MessageBox.updateProgress(percentage, message);
}

/*
 * fkt speichert Properties mit mehreren Aktionen gleichzeitig oPropsArray: {
 * path:'////', value:value, message:'huhu'}
 * 
 * saveEvent: { name:'xxx',parameter:{} }
 * 
 * finishAction: FKT wird nach dem Speichern aufgerufen
 * 
 */

// v2 approved
function stepProps(oPropsArray, saveEvent, finishAction, iStep) {
	var iMax = (oPropsArray.length * 2 + 1) * 1.0;
	if (iStep < (oPropsArray.length * 2)) {
		var iPropsIndex = Math.floor(iStep / 2);
		var oPropProperty = oPropsArray[iPropsIndex];
		if ((iStep % 2) == 0) {
			var sURL = "";
			var sPfad = escape(oPropProperty.path);

			if (typeof (oPropProperty.value) == "number") {
				sURL = '/json/property/setInteger';// ?path=' + sPfad +
				// "&value=" +
				// (sValue);
			} else {
				if (typeof (oPropProperty.value) == "boolean")
					sURL = '/json/property/setBoolean';// ?path=' + sPfad +
				// "&value=" +
				// (sValue);
				else
					sURL = '/json/property/setString';// ?path=' + sPfad +
				// "&value=" +
				// (sValue);

			}
			window.setTimeout(function() {
				ajaxAssyncRequestWithoutAnswer(sURL, {
					'path' : sPfad,
					'value' : (oPropProperty.value)
				}, function() {
					stepProps(oPropsArray, saveEvent, finishAction, iStep + 1);
				});
			}, 1);
			updateWaitDialog(iStep / iMax, oPropProperty.message);
		} else {
			var sURL = '/json/property/setFlag';
			var sPfad = escape(oPropProperty.path);
			window.setTimeout(function() {
				ajaxAssyncRequestWithoutAnswer(sURL, {
					'path' : sPfad,
					'value' : 'true',
					'flag' : 'ARCHIVE'
				}, function() {
					stepProps(oPropsArray, saveEvent, finishAction, iStep + 1);
				});
			}, 1);

			updateWaitDialog(iStep / iMax, oPropProperty.message);
		}
	} else if (iStep == (oPropsArray.length * 2)) {

		var sURL = '/json/event/raise';
		var paramString = "";
		for ( var key in saveEvent.parameter) {
			paramString += key + "="
					+ encodeURIComponent(saveEvent.parameter[key]) + ";";
		}
		window.setTimeout(function() {
			ajaxAssyncRequestWithoutAnswer(sURL, {
				'name' : saveEvent.name,
				'parameter' : paramString.substr(0, paramString.length - 1)
			}, function() {
				stepProps(oPropsArray, saveEvent, finishAction, iStep + 1);
			});
		}, 1);
		updateWaitDialog(iStep / iMax, saveEvent.message);
	} else {
		finishAction();
		hideWaitDialog();
	}
}

// v2 approved
function bulkPropertySave(oPropsArray, saveEvent, finishAction) {
	showWaitDialog('Speichere Daten');
	stepProps(oPropsArray, saveEvent, finishAction, 0);
}

// v2 approved
function getZoneStore() {
	if (Ext.data.StoreManager.lookup('zoneStore') == null) {
		Ext.create('Ext.data.Store', {
			storeId : 'zoneStore',
			fields : [ 'ZoneID', 'name' ],
			proxy : {
				type : 'memory',
				reader : {
					type : 'json',
					root : 'items'
				}
			}
		});
		Ext.data.StoreManager.lookup('zoneStore').add(getZoneArray());
	}
	return Ext.data.StoreManager.lookup('zoneStore');
}

// v2 approved
function getGroupStore(ZoneID) {
	if (nameCache == null)
		initCaches();
	if (Ext.data.StoreManager.lookup('groupStore_' + ZoneID) == null) {
		Ext.create('Ext.data.Store', {
			storeId : 'groupStore_' + ZoneID,
			fields : [ 'group', 'name', 'icon', 'reachable' ],
			proxy : {
				type : 'memory',
				reader : {
					type : 'json',
					root : 'items'
				}
			}
		});
		var oGroup = getGroupForZone(ZoneID);
		Ext.data.StoreManager.lookup('groupStore_' + ZoneID).add(oGroup);
	}
	return Ext.data.StoreManager.lookup('groupStore_' + ZoneID);
}

// v2 approved
function getSceneStore(ZoneID, groupID) {
	if (nameCache == null)
		initCaches();

	if (Ext.data.StoreManager.lookup('szeneStore_' + ZoneID + '_' + groupID) == null) {
		Ext.create('Ext.data.Store', {
			storeId : 'szeneStore_' + ZoneID + '_' + groupID,
			fields : [ 'id', 'name', 'reachable', 'icon' ],
			proxy : {
				type : 'memory',
				reader : {
					type : 'json',
					root : 'items'
				}
			}
		});
		var oScenes = getScenes(ZoneID, groupID);
		Ext.data.StoreManager.lookup('szeneStore_' + ZoneID + '_' + groupID)
				.add(oScenes);
	}
	return Ext.data.StoreManager.lookup('szeneStore_' + ZoneID + '_' + groupID);

}

// v2
function initAppDataStore(itemDev, storeID) {
	var sID = 'appDataStore';
	if (storeID != null)
		sID += "_" + storeID;
	Ext.create('Ext.data.Store', {
		storeId : sID,
		fields : itemDev,
		proxy : {
			type : 'memory',
			reader : {
				type : 'json',
				root : 'items'
			}
		}
	});
}

// v2
function fillAppDataStore(data, storeID) {
	var sID = 'appDataStore';
	if (storeID != null)
		sID += "_" + storeID;
	Ext.data.StoreManager.lookup(sID).removeAll();
	Ext.data.StoreManager.lookup(sID).add(data);
}

// v2
function getDefaultRenderer(col) {
	if (col.type == 'action') {
		return function(val, metadata, record, colIdx, store, view) {
			var tapId;
			var sString = '<table>';

			if (view.storeId != 'appDataStore') {
				tapId = view.storeId.substring(13);
				if (multiPassiveColumn[tapId] != null)
					if (record.get(multiPassiveColumn[tapId]) != null)
						if (record.get(multiPassiveColumn[tapId]) == true)
							sString = '<table style="color:#888888;">';
			}

			var actionObject = record.get(col.name);

			var fWithDelay = false;
			for ( var iIndex = 0; iIndex < actionObject.length; iIndex++) {
				var subObject = actionObject[iIndex];
				if (subObject.delay != null)
					fWithDelay = true;
			}
			for ( var iIndex = 0; iIndex < actionObject.length; iIndex++) {
				var subObject = actionObject[iIndex];
				sString += "<tr>";
				if (fWithDelay) {
					sString += '<td style="padding-left:3px;padding-right:3px;vertical-align:middle;">+</td><td style="text-align:right;padding-left:3px;padding-right:3px;vertical-align:middle;">';
					if (subObject.delay != null) {
						sString += "" + (subObject.delay / 1);
					} else
						sString += '0';
					sString += '</td><td style="padding-left:3px;padding-right:3px;vertical-align:middle;">Min.:</td>';
				}

				if (subObject.scene != null)  {
					var sceneGroup = 0;
					var sceneZone = 0;

					if (subObject.zone != null) {
						sceneGroup = subObject.group;
						sceneZone = subObject.zone;
					} else {
						var deviceObject = getDevice(subObject.device);
						sceneZone=deviceObject.ZoneID;
						sceneGroup=deviceObject.GroupID;
					}
	
					sString += '<td style="padding-left:3px;padding-right:3px;vertical-align:middle;">'
							+ getNameForScene(subObject.zone, subObject.group,
									subObject.scene) + '</td><td>f&uuml;r</td>';					
				} else {
					sString += '<td colspan="2"></td>';
				}
				
				if (subObject.zone != null) {
					sString += '<td style="padding-left:3px;padding-right:3px;vertical-align:middle;">'
							+ getNameForGroup(subObject.zone, subObject.group)
							+ "</td>";
					sString += '<td style="padding-left:3px;padding-right:3px;vertical-align:middle;"> in '
							+ getNameForZone(subObject.zone) + "</td>";
				} else {
					var deviceObject = getDevice(subObject.device);
					sString += '<td style="padding-left:3px;padding-right:3px;vertical-align:middle;">'
						+ deviceObject.name + '</td>';
					sString += '<td style="padding-left:3px;padding-right:3px;vertical-align:middle;"> in '
						+ getNameForZone(deviceObject.ZoneID) + "</td>";
				}
				
				if (subObject.scene != null)  {
					sString += "<td></td>";
				} else if (subObject.outputValue != null) {
					sString += '<td style="padding-left:3px;padding-right:3px;vertical-align:middle;" >: '
							+ subObject.outputValue + '%</td>';
				} else {
					sString += '<td style="padding-left:3px;padding-right:3px;vertical-align:middle;">blinken</td>';
				}
				

				sString += "</tr>";
			}
			return sString + "</table>";
		}
	} else if (col.type == 'action_colorful') {
		return function(val, metadata, record, colIdx, store, view) {
			var tapId;
			var sString = '<table>';

			if (view.storeId != 'appDataStore') {
				tapId = view.storeId.substring(13);
				if (multiPassiveColumn[tapId] != null)
					if (record.get(multiPassiveColumn[tapId]) != null)
						if (record.get(multiPassiveColumn[tapId]) == true)
							sString = '<table style="color:#888888;">';
			}

			var actionObject = record.get(col.name);

			var fWithDelay = false;
			for ( var iIndex = 0; iIndex < actionObject.length; iIndex++) {
				var subObject = actionObject[iIndex];
				if (subObject.delay != null)
					fWithDelay = true;
			}
			for ( var iIndex = 0; iIndex < actionObject.length; iIndex++) {
				var subObject = actionObject[iIndex];
				sString += "<tr>";
				if (fWithDelay) {
					sString += '<td style="padding-left:3px;padding-right:3px;vertical-align:middle;">+</td><td style="text-align:right;padding-left:3px;padding-right:3px;vertical-align:middle;">';
					if (subObject.delay != null) {
						sString += "" + (subObject.delay / 1);
					} else
						sString += '0';
					sString += '</td><td style="padding-left:3px;padding-right:3px;vertical-align:middle;">Min.:</td>';
				}
				if (subObject.scene != null) {
					var sceneGroup = 0;
					var sceneZone = 0;
					if (subObject.zone != null) {
						sceneGroup = subObject.group;
						sceneZone = subObject.zone;
					} else {

					}
					sString += '<td style="padding-left:3px;padding-right:3px;vertical-align:middle;">'
							+ getImageForScene(subObject.zone, subObject.group,
									subObject.scene) + '</td>';
					sString += '<td style="padding-left:3px;padding-right:3px;vertical-align:middle;">'
							+ getNameForScene(subObject.zone, subObject.group,
									subObject.scene) + '</td>';
				} else if (subObject.outputValue != null)
					sString += '<td style="padding-left:3px;padding-right:3px;vertical-align:middle;" colspan="2">Ausgang auf '
							+ subObject.outputValue + '%</td>';
				else
					sString += '<td style="padding-left:3px;padding-right:3px;vertical-align:middle;" colspan="2">Blinken</td>';

				if (subObject.zone != null) {
					sString += '<td style="padding-left:3px;padding-right:3px;vertical-align:middle;">f&uuml;r</td>';
					sString += '<td style="padding-left:3px;padding-right:3px;vertical-align:middle;">'
							+ getImageForGroup(subObject.zone, subObject.group)
							+ '</td>';
					sString += '<td style="padding-left:3px;padding-right:3px;vertical-align:middle;">'
							+ getNameForGroup(subObject.zone, subObject.group)
							+ "</td>";
					sString += '<td style="padding-left:3px;padding-right:3px;vertical-align:middle;"> in '
							+ getNameForZone(subObject.zone) + "</td>";
				} else {
					var deviceObject = getDevice(subObject.device);
					sString += '<td style="padding-left:3px;padding-right:3px;vertical-align:middle;">f&uuml;r</td>';
					sString += '<td style="padding-left:3px;padding-right:3px;vertical-align:middle;"><img src='
							+ getImageForDevice(deviceObject) + '></td>';
					sString += '<td style="padding-left:3px;padding-right:3px;vertical-align:middle;" colspan="2">'
							+ deviceObject.name + '</td>';
				}

				sString += "</tr>";
			}
			return sString + "</table>";
		}
	} else if (col.type == 'trigger_colorful') {
		return function(val, metadata, record, colIdx, store, view) {
			var triggerObject = record.get(col.name);

			var sString = "<table>";
			if (view.storeId != 'appDataStore') {
				tapId = view.storeId.substring(13);
				if (multiPassiveColumn[tapId] != null)
					if (record.get(multiPassiveColumn[tapId]) != null)
						if (record.get(multiPassiveColumn[tapId]) == true)
							sString = '<table style="color:#888888;">';
			}
			
			sString += "<tr><td>Raum:</td><td>"
					+ getNameForZone(triggerObject.zone) + "</td></tr>";
			sString += "<tr><td>Farbe:</td><td>"
					+ getImageForGroup(triggerObject.zone, triggerObject.group)
					+ " "
					+ getNameForGroup(triggerObject.zone, triggerObject.group)
					+ "</td></tr>";
			sString += "<tr><td>Aktivit&auml;t:</td><td>"
					+ getImageForScene(triggerObject.zone, triggerObject.group,
							triggerObject.scene)
					+ " "
					+ getNameForScene(triggerObject.zone, triggerObject.group,
							triggerObject.scene) + "</td></tr>";			
			
			
			sString += "</table>";

			return sString;
		}
	} else if (col.type == 'trigger') {
		return function(val, metadata, record, colIdx, store, view) {
			var triggerObject = record.get(col.name);

			var sString = "<table>";
			if (view.storeId != 'appDataStore') {
				tapId = view.storeId.substring(13);
				if (multiPassiveColumn[tapId] != null)
					if (record.get(multiPassiveColumn[tapId]) != null)
						if (record.get(multiPassiveColumn[tapId]) == true)
							sString = '<table style="color:#888888;">';
			}

			sString+="<tr><td>" + getNameForScene(triggerObject.zone,triggerObject.group,triggerObject.scene);
			sString+=" f&uuml;r " + " " + getNameForGroup(triggerObject.zone,triggerObject.group);
			sString+=" in " + getNameForZone(triggerObject.zone) + "</td></tr>";
			
			sString += "</table>";

			return sString;
		}
	} else if (col.type == 'message') {
		return function(val, metadata, record, colIdx, store, view) {
			var sString = "<table>"
			if (view.storeId != 'appDataStore') {
				tapId = view.storeId.substring(13);
				if (multiPassiveColumn[tapId] != null)
					if (record.get(multiPassiveColumn[tapId]) != null)
						if (record.get(multiPassiveColumn[tapId]) == true)
							sString = '<table style="color:#888888;">';
			}

			var triggerObject = record.get(col.name);
			if (triggerObject.messageType == 'email')
				return sString
						+ '<tr><td rowspan="3"><image src="images/dss/email.png"></td>'
						+ '<td rowspan="3" style="width:5px;"><image src="t.gif"></td>'
						+ '<td>Empf&auml;nger:</td><td>'
						+ triggerObject.receiver + '</td></tr>'
						+ '<tr><td>Betreff:</td><td>' + triggerObject.subject
						+ '</td></tr>' + '<tr><td>Nachricht:</td><td>'
						+ triggerObject.message + '</td></tr></table>';
			else
				return "eine Nachricht";
		}
	} else if (col.type == 'datetime') {
		return function(val, metadata, record, colIdx, store, view) {

			var DateObject = new Date(record.get(col.name) * 1000);
			var sString = "<span>";
			if (view.storeId != 'appDataStore') {
				tapId = view.storeId.substring(13);
				if (multiPassiveColumn[tapId] != null)
					if (record.get(multiPassiveColumn[tapId]) != null)
						if (record.get(multiPassiveColumn[tapId]) == true)
							sString = '<span style="color:#888888;">';
			}

			return sString + Ext.Date.format(DateObject, "l, d.m.Y, H:i")
					+ " Uhr</span>";
		}
	} else if (col.type == 'time') {
		return function(val, metadata, record, colIdx, store, view) {
			var DateObject = new Date(record.get(col.name) * 1000);
			var sString = "<span>";
			if (view.storeId != 'appDataStore') {
				tapId = view.storeId.substring(13);
				if (multiPassiveColumn[tapId] != null)
					if (record.get(multiPassiveColumn[tapId]) != null)
						if (record.get(multiPassiveColumn[tapId]) == true)
							sString = '<span style="color:#888888;">';
			}
			return sString + Ext.Date.format(DateObject, "H:i") + " Uhr</span>";
		}
	} else if (col.type == 'time_with_random') {
		return function(val, metadata, record, colIdx, store, view) {			
			var sString = "<span>";
			if (view.storeId != 'appDataStore') {
				tapId = view.storeId.substring(13);
				if (multiPassiveColumn[tapId] != null)
					if (record.get(multiPassiveColumn[tapId]) != null)
						if (record.get(multiPassiveColumn[tapId]) == true)
							sString = '<span style="color:#888888;">';
			}
			var sText="";
			if (record.get(col.name).start!=null) {
				var DateObject = new Date(record.get(col.name).start * 1000);
				sText=Ext.Date.format(DateObject, "H:i") + " Uhr";
			} else
				if (record.get(col.name).sunset!=null) {
					
					var iSunset=record.get(col.name).sunset;
					sText=pad(Math.floor(Math.abs(iSunset/3600))) + ":" +
					pad(Math.floor(Math.abs(iSunset/60)%60)) + ":" +
					pad(Math.floor(Math.abs(iSunset%60)));
					if (iSunset<0)
						sText += "<br>vor Sonnenuntergang";
					else
						sText += "<br>nach Sonnenuntergang";
				} else
					if (record.get(col.name).sunrise!=null) {
						var iSunrise=record.get(col.name).sunrise;
						sText=pad(Math.floor(Math.abs(iSunrise/3600))) + ":" +
						pad(Math.floor(Math.abs(iSunrise/60)%60)) + ":" +
						pad(Math.floor(Math.abs(iSunrise%60)));
						if (iSunrise<0)
							sText += "<br>vor Sonnenaufgang";
						else
							sText += "<br>nach Sonnenaufgang";
					} else {
						if (col.additionalTimeRef!=null){
							for (var lIndex=0;lIndex<col.additionalTimeRef.length;lIndex++)
								{
									if (record.get(col.name)[col.additionalTimeRef[lIndex].name]!=null) {
										var iDate=record.get(col.name)[col.additionalTimeRef[lIndex].name];
										sText=pad(Math.floor(Math.abs(iDate/3600))) + ":" +
										pad(Math.floor(Math.abs(iDate/60)%60)) + ":" +
										pad(Math.floor(Math.abs(iDate%60)));
										if (iDate<0)
											sText += col.additionalTimeRef[lIndex].renderNeg;
										else
											sText += col.additionalTimeRef[lIndex].renderPos;
									}
								}
						} 
					}
			if (record.get(col.name).maxdiv > 0)
				sString += "&plusmn; "
			return sString + sText + "</span>";
		}
	} else if (col.type == 'recurrence_weekly') {
		return function(val, metadata, record, colIdx, store, view) {
			var sString = "<span>";
			if (view.storeId != 'appDataStore') {
				tapId = view.storeId.substring(13);
				if (multiPassiveColumn[tapId] != null)
					if (record.get(multiPassiveColumn[tapId]) != null)
						if (record.get(multiPassiveColumn[tapId]) == true)
							sString = '<span style="color:#888888;">';
			}
			var fMo = false;
			var fDi = false;
			var fMi = false;
			var fDo = false;
			var fFr = false;
			var fSa = false;
			var fSo = false;
			var recObject = record.get(col.name);
			if (recObject.length == 7)
				return sString + "t&auml;glich</span>";
			for ( var iIndex = 0; iIndex < recObject.length; iIndex++) {
				if (recObject[iIndex] == 'MO')
					fMo = true;
				if (recObject[iIndex] == 'TU')
					fDi = true;
				if (recObject[iIndex] == 'WE')
					fMi = true;
				if (recObject[iIndex] == 'TH')
					fDo = true;
				if (recObject[iIndex] == 'FR')
					fFr = true;
				if (recObject[iIndex] == 'SA')
					fSa = true;
				if (recObject[iIndex] == 'SU')
					fSo = true;
			}
			if (recObject.length == 2)
				if (fSa)
					if (fSo)
						return sString + 'am Wochenende</span>';

			if (recObject.length == 5)
				if (fMo)
					if (fDi)
						if (fMi)
							if (fDo)
								if (fFr)
									return sString + 'an Werktagen</span>';
			if (recObject.length == 1) {
				if (fMo)
					return sString + "Montags</span>";
				if (fDi)
					return sString + "Dienstags</span>";
				if (fMi)
					return sString + "Mittwochs</span>";
				if (fDo)
					return sString + "Donnerstags</span>";
				if (fFr)
					return sString + "Freitags</span>";
				if (fSa)
					return sString + "Samstags</span>";
				if (fSo)
					return sString + "Sonntags</span>";
			}

			if (fMo)
				sString += '<b>MO</b> ,';
			else
				sString += '<span style="color:#aaaaaa;text-decoration:line-through;">MO</span> ,';
			if (fDi)
				sString += '<b>DI</b> ,';
			else
				sString += '<span style="color:#aaaaaa;text-decoration:line-through;">DI</span> ,';
			if (fMi)
				sString += '<b>MI</b> ,';
			else
				sString += '<span style="color:#aaaaaa;text-decoration:line-through;">MI</span> ,';
			if (fDo)
				sString += '<b>DO</b> ,';
			else
				sString += '<span style="color:#aaaaaa;text-decoration:line-through;">DO</span> ,';
			if (fFr)
				sString += '<b>FR</b> ,';
			else
				sString += '<span style="color:#aaaaaa;text-decoration:line-through;">FR</span> ,';
			if (fSa)
				sString += '<b>SA</b> ,';
			else
				sString += '<span style="color:#aaaaaa;text-decoration:line-through;">SA</span> ,';
			if (fSo)
				sString += '<b>SO</b>';
			else
				sString += '<span style="color:#aaaaaa;text-decoration:line-through;">SO</span>';
			return sString + "</span>";

		}
	} else if (col.type == 'string') {
		return function(val, metadata, record, colIdx, store, view) {
			var sString = "<span>";
			if (view.storeId != 'appDataStore') {
				tapId = view.storeId.substring(13);
				if (multiPassiveColumn[tapId] != null)
					if (record.get(multiPassiveColumn[tapId]) != null)
						if (record.get(multiPassiveColumn[tapId]) == true)
							sString = '<span style="color:#888888;">';
			}
			return sString + unescape(record.get(col.name)) + "</span>";
		}
	}
	return null;
}

function setSimpleValue(id,controlId,value)
{
	var pCol = [];
	for ( var iIndex = 0; iIndex < columnDef.length; iIndex++)
		if (columnDef[iIndex].id == id)
			pCol = columnDef[iIndex].items;

	var oNewObject = {};
	for (var jIndex=0;jIndex<pCol.length;jIndex++)
	{
		var colDef = pCol[jIndex].content;		
		for ( var iIndex = 0; iIndex < colDef.length; iIndex++) {
			var col = colDef[iIndex];
			if (col.id==controlId) {
				if (col.type=='choose') {
					var oObject={};
					oObject[controlId]=value;
					multiEditorWindow[id].editControls[controlId].stepOver=true;
					multiEditorWindow[id].editControls[controlId].setValue(oObject);
					multiEditorWindow[id].editControls[controlId].stepOver=false;
				}
				if (col.type=='text_email') {
					multiEditorWindow[id].editControls[controlId].stepOver=true;
					multiEditorWindow[id].editControls[controlId].setValue(value);				
					multiEditorWindow[id].editControls[controlId].stepOver=false;
				}
				if (col.type=='email_with_enabler')
				{
					if (value.choose!=null) {
						multiEditorWindow[id].editControls[controlId+"_yes"].stepOver=true;
						multiEditorWindow[id].editControls[controlId+"_yes"].setValue(value.choose);
						multiEditorWindow[id].editControls[controlId+"_yes"].stepOver=false;
					}
					if (value.receiver!=null)
					{
						multiEditorWindow[id].editControls[controlId+"_email"].stepOver=true;
						multiEditorWindow[id].editControls[controlId+"_email"].setValue(value.receiver);
						multiEditorWindow[id].editControls[controlId+"_email"].stepOver=false;
					}
				}
			}
		}
	}
}

// v0
function buildSimplePanel(panelDev) {
	var id = panelDev.id;
	
	var basepanel = Ext.create('Ext.form.Panel', {
		title : panelDev.name,
		bodyPadding : 5,
		autoScroll:true,
		border : 0
	});
	multiPanelArray[id]=basepanel;
	if (panelDev.items!=null)
	{
		multiEditorWindow[id]={};
		multiEditorWindow[id].editControls = {};
		for (var kIndex=0;kIndex<panelDev.items.length;kIndex++) 
		{
			var oGroup=panelDev.items[kIndex];
			var panel= Ext.create('Ext.form.FieldSet',{
				title:oGroup.label			
			});
			basepanel.add(panel);
			for (var iIndex=0;iIndex<oGroup.content.length;iIndex++)
			{
				var oObject=oGroup.content[iIndex];
				if (oObject.type=="static")
				{
					var subpanel = Ext.create('Ext.form.Panel', {
						border : 0,
						html:oObject.html,
						style: {color:"#005138"}
					});
					panel.add(subpanel);
				}
				else if (oObject.type=="auto_query")
				{
					var subpanel = Ext.create('Ext.form.Panel', {
						border : 0,
						html:'<div id="subPanel_' + oObject.id + '">' + oObject.changeListener() + '</div>',
						style: {color:"#005138"}
					});
					panel.add(subpanel);
					multiEditorWindow[id].editControls[oObject.id]=subpanel;
					var oTempValue='subPanel_' + oObject.id;
					var oTempFunction= oObject.changeListener;
					var oFunct=function()
					{						
						if (document.getElementById(oTempValue)!=null){					
							document.getElementById(oTempValue).innerHTML=oTempFunction();
						}
					}
					window.setInterval(oFunct,5*1000);
				}
				else if (oObject.type=="text_email")
				{
					var oControl = Ext.create('Ext.form.field.Text', {
						name : 'edit_' + oObject.id + '_email',
						fieldLabel : oObject.title,
						allowBlank : false,
						regex : /\b[A-Z0-9._%-]+@[A-Z0-9.-]+\.[A-Z]{2,4}\b/i,
						regexText : 'Die Emailadresse ist fehlerhaft',
						style: {color:"#005138"}					
					});
					oControl.ownHandlerChange=panelDev.items[kIndex].content[iIndex].changeListener;
					oControl.addListener('blur',function(oThis) {
						if (oThis.stepOver)
							return;
						if (this.ownHandlerChange!=null)
							this.ownHandlerChange(this.getValue());
					});
					
					multiEditorWindow[id].editControls[oObject.id]=oControl;

					if (oObject.buttonTitle!=null) {
						var subpanel = Ext.create('Ext.Panel', {
							border : 0,
							width : 400,
							layout: {
						        type: 'hbox',
						        align: 'center'
						    }

						});
						
						var oButton=Ext.create('Ext.button.Button',{
							text:oObject.buttonTitle,
							handler:function() {oControl.ownHandlerChange(oControl.getValue());}
						});
						multiEditorWindow[id].editControls[oObject.id+"_button"]=oButton;
						subpanel.add(oControl);
						subpanel.add(oButton);
						panel.add(subpanel);
					} else 
						panel.add(oControl);
				}
				else if (oObject.type=="choose")
				{				
					var aItems=[];
					for (var jIndex=0;jIndex<oObject.options.length;jIndex++)
					{
						var oItems={};
						oItems.boxLabel=oObject.options[jIndex].text;
						oItems.inputValue=oObject.options[jIndex].value;
						oItems.name=""+oObject.id;
						aItems.push(oItems);
					}
					var oSubPanel=Ext.create('Ext.form.RadioGroup',{
						fieldLabel:oObject.title,
						items:aItems,
						columns:1,
						labelAlign:'top',
						style: {color:"#005138"}
					});
					oSubPanel.ownHandlerChange=panelDev.items[kIndex].content[iIndex].changeListener;
					oSubPanel.addListener('change',function(oThis,newValue,oldValue,eOpts) {
						if (oThis.stepOver)
							return
						for (var oKey in newValue)
							if (typeof(newValue[oKey])!='object')
								if (this.ownHandlerChange!=null)
									this.ownHandlerChange(newValue[oKey]);
						
					});
					multiEditorWindow[id].editControls[oObject.id]=oSubPanel;
					panel.add(oSubPanel);
				} else if (oObject.type=="button")
				{
					var oButton=Ext.create('Ext.button.Button',{
						text:oObject.title,
						handler:oObject.changeListener});
					multiEditorWindow[id].editControls[oObject.id]=oButton;
					panel.add(oButton);
				} else if (oObject.type="email_with_enabler")
				{
										
					var description = Ext.create('Ext.form.Panel', {
						border : 0,
						html:oObject.titleEnabler,
						style: {color:"#005138"},
						colspan:3
					});
					
					var oNo= Ext.create('Ext.form.field.Radio',{
						name : 'edit_' + oObject.id + '_email_enabler',
						inputValue : 'no',
						boxLabel: 'Nein',
						colspan:3,
						style: {color:"#005138"}
					});
					var oYes= Ext.create('Ext.form.field.Radio',{
						name : 'edit_' + oObject.id + '_email_enabler',
						inputValue : 'yes',
						boxLabel: 'Ja',
						width:100,
						style: {color:"#005138"}	
					});
					
					
					var oControl = Ext.create('Ext.form.field.Text', {
						name : 'edit_' + oObject.id + '_email',
						id : 'edit_' + oObject.id + '_email',
						fieldLabel : oObject.title,
						allowBlank : false,
						regex : /\b[A-Z0-9._%-]+@[A-Z0-9.-]+\.[A-Z]{2,4}\b/i,
						regexText : 'Die Emailadresse ist fehlerhaft',
						style: {color:"#005138"},
						width:400,
						labelWidth:65
					});
					oControl.ownHandlerChange=panelDev.items[kIndex].content[iIndex].changeListener;
					if (oObject.buttonTitle==null)
						oControl.addListener('blur',function(oThis) {
							if (oThis.stepOver)
								return;
							if (this.ownHandlerChange!=null)
								this.ownHandlerChange(oYes.getValue(),oControl.getValue());
						});
						
					var yesPanel = Ext.create('Ext.Panel', {
						border : 0,
						width : 600,
						layout: {
					        type: 'hbox',
					        align: 'center'
					    },
					    items:[oYes,oControl]
					});
					oYes.ownHandlerChange=panelDev.items[kIndex].content[iIndex].changeListener;
					oYes.addListener('change',function(oThis,newValue,oldValue,eOpts) {
						if (newValue)
							oControl.enable();
				    	else
				    		oControl.disable();
						
						if (oThis.stepOver)
							return;
						if (this.ownHandlerChange!=null)
							this.ownHandlerChange(oYes.getValue(),oControl.getValue());
					});
					oNo.addListener('change',function(oThis,newValue,oldValue,eOpts) {
						if (!newValue)
							oControl.enable();
				    	else
				    		oControl.disable();
				    });

					
					if (oObject.buttonTitle!=null) {						
						var oButton=Ext.create('Ext.button.Button',{
							text:oObject.buttonTitle,
							handler:function() {oControl.ownHandlerChange(oYes.getValue(),oControl.getValue());}
						});
						multiEditorWindow[id].editControls[oObject.id+"_button"]=oButton;
						yesPanel.add(oButton);					

						oYes.addListener('change',function(oThis,newValue,oldValue,eOpts) {
							if (newValue)
								oButton.enable();
					    	else
					    		oButton.disable();
					    });
						oNo.addListener('change',function(oThis,newValue,oldValue,eOpts) {
							if (!newValue)
								oButton.enable();
					    	else
					    		oButton.disable();
					    });
					}
															
					var oPanel = Ext.create('Ext.Panel', {
						layout: {
				            type: 'vbox'
				        },
				        border : 0,
				        height: 70,
				        width: 700,
				        items:[description,
				               oNo,
				               yesPanel]
					});
					
					multiEditorWindow[id].editControls[oObject.id]=oPanel;
					multiEditorWindow[id].editControls[oObject.id+"_yes"]=oYes;
					multiEditorWindow[id].editControls[oObject.id+"_no"]=oNo;
					multiEditorWindow[id].editControls[oObject.id+"_email"]=oControl;
					
					panel.add(oPanel);

				}
			}
		}
	}
	return basepanel;
}

function enableEditControl(id,control,enabled)
{
	var colDef = [];
	for ( var iIndex = 0; iIndex < columnDef.length; iIndex++)
		if (columnDef[iIndex].id == id)
			colDef = columnDef[iIndex].columns;
	var col={};
	for (var iIndex=0;iIndex<colDef.length;iIndex++)
		if (colDef[iIndex].name==control)
			col=colDef[iIndex];
	if (col.type=='string') {
		multiEditorWindow[id].editControls[col.name].setDisabled(!enabled);
	} else if (col.type=='recurrence_weekly') {
		multiEditorWindow[id].editControls[col.name + '_anzeige'].setDisabled(!enabled);
		multiEditorWindow[id].editControls[col.name + '_MOControl'].setDisabled(!enabled);
		multiEditorWindow[id].editControls[col.name + '_DIControl'].setDisabled(!enabled);
		multiEditorWindow[id].editControls[col.name + '_MIControl'].setDisabled(!enabled);
		multiEditorWindow[id].editControls[col.name + '_DOControl'].setDisabled(!enabled);
		multiEditorWindow[id].editControls[col.name + '_FRControl'].setDisabled(!enabled);
		multiEditorWindow[id].editControls[col.name + '_SAControl'].setDisabled(!enabled);
		multiEditorWindow[id].editControls[col.name + '_SOControl'].setDisabled(!enabled);
	} else if (col.type=='time_with_random') {
		multiEditorWindow[id].editControls[col.name + '_dateTypeControl'].setDisabled(!enabled);
		multiEditorWindow[id].editControls[col.name + '_deltaControl'].setDisabled(!enabled);
		multiEditorWindow[id].editControls[col.name + '_hourControl'].setDisabled(!enabled);
		multiEditorWindow[id].editControls[col.name + '_minuteControl'].setDisabled(!enabled);
		multiEditorWindow[id].editControls[col.name + '_randomControl'].setDisabled(!enabled);
	} else if (col.type=='datetime') {
		multiEditorWindow[id].editControls[col.name + '_dateControl'].setDisabled(!enabled);
		multiEditorWindow[id].editControls[col.name + '_hourControl'].setDisabled(!enabled);
		multiEditorWindow[id].editControls[col.name + '_minuteControl'].setDisabled(!enabled);
	} else if (col.type=='trigger') {
		multiEditorWindow[id].editControls[col.name + '_zoneCombo'].setDisabled(!enabled);
		multiEditorWindow[id].editControls[col.name + '_groupCombo'].setDisabled(!enabled);
		multiEditorWindow[id].editControls[col.name + '_sceneCombo'].setDisabled(!enabled);
		multiEditorWindow[id].editControls[col.name + '_checkAll'].setDisabled(!enabled);
	} else if (col.type=='message') {
		multiEditorWindow[id].editControls[controlDef.name + '_receiver'].setDisabled(!enabled);
		multiEditorWindow[id].editControls[controlDef.name + '_subject'].setDisabled(!enabled);
		multiEditorWindow[id].editControls[controlDef.name + '_body'].setDisabled(!enabled);						
	}
}

// v0
function buildEditWindow(panelDev) {
	var id = panelDev.id;
	var colDef = [];
	for ( var iIndex = 0; iIndex < panelDev.columns.length; iIndex++) {
		if (panelDev.columns[iIndex].editorOrder == null)
			panelDev.columns[iIndex].editorOrder = iIndex;
		colDef.push(panelDev.columns[iIndex]);
	}

	colDef.sort(function(a, b) {
		return Math.floor((a.editorOrder * 100) - (b.editorOrder * 100));
	});

	var editorPanel = Ext.create('Ext.form.Panel', {
		bodyPadding : 5,
		border : 0,
		autoScroll:true,
		scroll:'vertical',
		buttons : [ {
			text : 'Abbruch',
			handler : function() {
				multiEditorWindow[id].hide();
			}
		}, {
			text : 'Speichern',
			handler : function() {
				var fValid = true;
				for ( var sKey in multiEditorWindow[id].editControls) {
					var oControl = multiEditorWindow[id].editControls[sKey];

					if (oControl.isValid != null)
						if (!oControl.isValid())
							fValid = false;
				}
				if (fValid) {
					saveCallback(getObjectData(id),id);
					multiEditorWindow[id].hide();
				}
			}
		} ]
	});

	multiEditorWindow[id] = Ext.create('Ext.window.Window', {
		closeAction : 'hide',
		title : baseValues.editorTitle[id],
		modal : true, // Exclusive input for the window
		width : 725,
		layout : 'fit',
		items : [ editorPanel ]
	});

	multiEditorWindow[id].editControls = {};
	var iHeight = 77;
	for ( var iIndex = 0; iIndex < colDef.length; iIndex++) {
		var col = colDef[iIndex];
		if (col.type == 'string') {
			var oControl = Ext.create('Ext.form.field.Text', {
				name : 'edit_' + col.name,
				fieldLabel : col.title,
				allowBlank : false,
				width : 600,
				labelWidth : 80,
				blankText : col.title + ' muss ausgef&uuml;llt werden',
				invalidText : col.title + ' muss ausgef&uuml;llt werden'
			});
			editorPanel.add(oControl);
			multiEditorWindow[id].editControls[col.name] = oControl;
			iHeight += 27;
		} else if (col.type == 'action') {

			Ext.create('Ext.data.Store', {
				storeId : 'editWindowStore_' + col.name + '_' + id,
				fields : [ 'zoneID', 'groupID', 'sceneID', 'deltaTime' ],
				proxy : {
					type : 'memory',
					reader : {
						type : 'json',
						root : 'items'
					}
				}
			});
			var gridStore = Ext.data.StoreManager.lookup('editWindowStore_'
					+ col.name + '_' + id);
			gridStore.removeAll;
			gridStore.add({
				'zoneID' : null,
				'groupID' : null,
				'sceneID' : null,
				'deltaTime' : 0
			});

			var cellEditing = Ext.create('Ext.grid.plugin.CellEditing', {
				clicksToEdit : 1
			});

			var oGroupStore = Ext.create('Ext.data.Store', {
				fields : [ 'group', 'name', 'icon' ],
				proxy : {
					type : 'memory',
					reader : {
						type : 'json',
						root : 'items'
					}
				}
			});

			var oSceneStore = Ext.create('Ext.data.Store', {
				fields : [ 'id', 'name', 'reachable', 'icon' ],
				proxy : {
					type : 'memory',
					reader : {
						type : 'json',
						root : 'items'
					}
				}
			});
			var selModel=Ext.create('Ext.selection.CellModel',{allowDeselect:true,mode:'SINGLE'});
			var gridPanel = Ext
					.create(
							'Ext.grid.Panel',
							{
								title : panelDev.name,
								store : gridStore,
								selModel : selModel,
//								selType : 'cellmodel',
								plugins : [ cellEditing ],
								border : 1,
								columns : [
										{
											id : 'col-editGrid-' + col.name
													+ '-' + id + '-delay',
											header : "Verz&ouml;gerung",
											dataIndex : 'deltaTime',
											hideable : false,
											renderer : function(val, metadata,
													record, colIdx, store, view) {
												if (record.get('deltaTime') == null)
													return '<span style="color:#ff0000;">-</span>';
												else
													return '+ '
															+ Math
																	.floor(record
																			.get('deltaTime') / 1)
															+ ' Minuten';
											},
											editor : {
												xtype : 'numberfield',
												allowBlank : false,
												minValue : 0,
												maxValue : 100000
											},
											width : 100
										},
										{
											id : 'col-editGrid-' + col.name
													+ '-' + id + '-zone',
											header : "Raum",
											dataIndex : 'zoneID',
											hideable : false,
											editor : {
												xtype : 'combobox',
												store : getZoneStore(),
												queryMode : 'local',
												valueField : 'ZoneID',
												displayField : 'name',
												allowBlank : false,
												blankText : 'Ein Raum muss gew&auml;hlt werden',
												invalidText : 'Ein Raum muss gew&auml;hlt werden',
												forceSelection : true,
												listConfig : {
													maxHeight : 300
												},
												editable : false,
												listeners : {
													focus : {
														fn : function(oThis) {
															oThis.expand();
														}
													},
													show : {
														fn : function(oThis) {
															oThis.expand();
														}
													},
													select : {
														fn : function(control,
																records, eOpts) {
															multiEditorWindow[eOpts.optId].editControls[eOpts.optColName].editingPlugin
																	.completeEdit();
														},
														scope : this,
														optId : id,
														optColName : col.name
													}
												}
											},
											renderer : function(val, metadata,
													record, colIdx, store, view) {
												if (record.get('zoneID') == null)
													return 'Bitte w&auml;hlen';
												else
													return getNameForZone(record
															.get('zoneID'));
											},
											flex : 1
										},
										{
											id : 'col-editGrid-' + col.name
													+ '-' + id + '-group',
											header : "Farbgruppe",
											dataIndex : 'groupID',
											hideable : false,
											editor : {
												xtype : 'combobox',
												store : oGroupStore,
												queryMode : 'local',
												listConfig : {
													getInnerTpl : function() {
														return '<div><img src="{icon}"> {name}</div>';
													},
													maxHeight : 300
												},
												valueField : 'group',
												displayField : 'name',
												forceSelection : true,
												editable : false,
												allowBlank : false,
												blankText : 'Eine Gruppe muss gew&auml;hlt werden',
												invalidText : 'Eine Gruppe muss gew&auml;hlt werden',
												listeners : {
													focus : {
														fn : function(oThis) {
															oThis.expand();
														}
													},
													show : {
														fn : function(oThis) {
															oThis.expand();
														}
													},
													select : {
														fn : function(control,
																records, eOpts) {
															multiEditorWindow[eOpts.optId].editControls[eOpts.optColName].editingPlugin
																	.completeEdit();
														},
														scope : this,
														optId : id,
														optColName : col.name
													}
												}
											},
											renderer : function(val, metadata,
													record, colIdx, store, view) {
												if (record.get('zoneID') == null)
													return '<span style="color:#888888;">Bitte Raum w&auml;hlen</span>';
												if (record.get('groupID') == null)
													return '<span style="color:#ff0000;">Bitte w&auml;hlen</span>';
												else
													return getImageForGroup(
															record
																	.get('zoneID'),
															record
																	.get('groupID'))
															+ ' '
															+ getNameForGroup(
																	record
																			.get('zoneID'),
																	record
																			.get('groupID'));
											},
											flex : 1
										},
										{
											id : 'col-editGrid-' + col.name
													+ '-' + id + '-scene',
											header : "Aktivit&auml;t",
											dataIndex : 'sceneID',
											hideable : false,
											editor : {
												xtype : 'combobox',
												store : oSceneStore,
												queryMode : 'local',
												listConfig : {
													getInnerTpl : function() {
														return '<div><img src="{icon}"> {name}</div>';
													},
													maxHeight : 300
												},
												valueField : 'id',
												displayField : 'name',
												forceSelection : true,
												editable : false,
												allowBlank : false,
												blankText : 'Eine Gruppe muss gew&auml;hlt werden',
												invalidText : 'Eine Gruppe muss gew&auml;hlt werden',
												listeners : {
													focus : {
														fn : function(oThis) {
															oThis.expand();
														}
													},
													show : {
														fn : function(oThis) {
															oThis.expand();
														}
													},
													select : {
														fn : function(control,
																records, eOpts) {
															multiEditorWindow[eOpts.optId].editControls[eOpts.optColName].editingPlugin
																	.completeEdit();
														},
														scope : this,
														optId : id,
														optColName : col.name
													}

												}
											},
											renderer : function(val, metadata,
													record, colIdx, store, view) {
												if (record.get('zoneID') == null)
													return '<span style="color:#888888;">Bitte Raum w&auml;hlen</span>';
												if (record.get('groupID') == null)
													return '<span style="color:#888888;">Bitte Gruppe w&auml;hlen</span>';
												if (record.get('sceneID') == null)
													return '<span style="color:#ff0000;">Bitte w&auml;hlen</span>';
												else
													return getImageForScene(
															record
																	.get('zoneID'),
															record
																	.get('groupID'),
															record
																	.get('sceneID'))
															+ ' '
															+ getNameForScene(
																	record
																			.get('zoneID'),
																	record
																			.get('groupID'),
																	record
																			.get('sceneID'));
											},
											flex : 1
										},
										{
											id : 'col-editGrid-' + col.name
													+ '-' + id + '-delete',
											header : "",
											dataIndex : 'nix',
											hideable : false,
											renderer : function() {
												return '<img src="images/dss/delete.png">';
											},
											width : 50
										} ],
								border : 1,
								enableColumnHide : false,
								viewConfig : {
									stripeRows : true
								},
								autoScroll:true,
								scroll:'vertical',
								width : 690,
								height : 270
							});
			gridPanel.on('beforeedit', function(eventObject) {
				var eGrid = eventObject.grid;
				var eRecord = eventObject.record;
				var eFieldName = eventObject.field;
				var fShouldBeFiltered = true;
				if (eFieldName == 'groupID') {
					if (eRecord.get('zoneID') == null)
						return false;
					
					var oGroupStoreTemp = getGroupStore(eRecord
							.get('zoneID'));
					oGroupStore.removeAll();
					
					oGroupStoreTemp.each(function(record) {
						var oNewRecord = record.copy();
						if (oNewRecord.get('reachable')
								|| (!fShouldBeFiltered)) 
							oGroupStore.add(oNewRecord);
					});	
					
				} else if (eFieldName == 'sceneID') {
					if ((eRecord.get('zoneID') == null)
							|| (eRecord.get('groupID') == null))
						return false;
					var oSceneStoreTemp = getSceneStore(eRecord
							.get('zoneID'), eRecord.get('groupID'));
					oSceneStore.removeAll();
					oSceneStoreTemp.each(function(record) {
						var oNewRecord = record.copy()
						if (oNewRecord.get('reachable')
								|| (!fShouldBeFiltered))
							oSceneStore.add(oNewRecord);
					});
				}
			});
			gridPanel.on('edit', function(editor, eventObject) {
				var eGrid = eventObject.grid;
				var eRecord = eventObject.record;
				var eFieldName = eventObject.field;
				eRecord.commit();
				var fShouldBeFiltered = true;
				if (eFieldName == 'zoneID')
					if (eRecord.get('zoneID') != null) {
						var oGroupStoreTemp = getGroupStore(eRecord
								.get('zoneID'));
						oGroupStore.removeAll();
						var fFirstReachableGroup=null;
						oGroupStoreTemp.each(function(record) {
							var oNewRecord = record.copy();
							if (oNewRecord.get('reachable'))
								if (fFirstReachableGroup==null)
									if (oNewRecord.get('group')!=0)
										fFirstReachableGroup=oNewRecord.get('group');
							if (oNewRecord.get('reachable')
									|| (!fShouldBeFiltered)) 
								oGroupStore.add(oNewRecord);
						});											
						
						eRecord.set('groupID', fFirstReachableGroup);
						if (fFirstReachableGroup!=null)
						{
							var oSceneStoreTemp = getSceneStore(eRecord
									.get('zoneID'), fFirstReachableGroup);
							oSceneStore.removeAll();
							oSceneStoreTemp.each(function(record) {
								var oNewRecord = record.copy()
								if (oNewRecord.get('reachable')
										|| (!fShouldBeFiltered))
									oSceneStore.add(oNewRecord);
							});							
						}
						eRecord.set('sceneID', null);
					}
				if (eFieldName == 'groupID')
					if ((eRecord.get('zoneID') != null)
							&& (eRecord.get('groupID') != null)) {
						var oSceneStoreTemp = getSceneStore(eRecord
								.get('zoneID'), eRecord.get('groupID'));
						oSceneStore.removeAll();
						oSceneStoreTemp.each(function(record) {
							var oNewRecord = record.copy()
							if (oNewRecord.get('reachable')
									|| (!fShouldBeFiltered))
								oSceneStore.add(oNewRecord);
						});
						eRecord.set('sceneID', null);
					}

				if ((eRecord.get('sceneID') != null)
						&& (eRecord.get('zoneID') != null)
						&& (eRecord.get('groupID') != null)
						&& (eRecord.get('deltaTime') != null)) {
					var gridStore = this.store;
					var fShouldAddEmptyColumn = true;
					gridStore.each(function(record) {
						if (record.get('zoneID') == null)
							fShouldAddEmptyColumn = false;
						if (record.get('groupID') == null)
							fShouldAddEmptyColumn = false;
						if (record.get('sceneID') == null)
							fShouldAddEmptyColumn = false;
					});
					if (fShouldAddEmptyColumn)
						gridStore.add({
							'zoneID' : null,
							'groupID' : null,
							'sceneID' : null,
							'deltaTime' : 0
						});
				}

			});
			gridPanel.on('cellClick', function(gridView, element, colIndex,
					record, colElement, rowIndex, c) {
				if (colIndex == 4) {
					var store = record.store;
					if (rowIndex < (store.getCount() - 1))
						store.removeAt(rowIndex);
					var fShouldAddEmptyColumn = true;
					store.each(function(record) {
						if (record.get('zoneID') == null)
							fShouldAddEmptyColumn = false;
						if (record.get('groupID') == null)
							fShouldAddEmptyColumn = false;
						if (record.get('sceneID') == null)
							fShouldAddEmptyColumn = false;
					});
					if (fShouldAddEmptyColumn)
						store.add({
							'zoneID' : null,
							'groupID' : null,
							'sceneID' : null,
							'deltaTime' : 0
						});
				}
			});
			multiEditorWindow[id].editControls[col.name] = gridPanel;
			editorPanel.add(gridPanel);
			iHeight += 270;
		} else if (col.type == 'recurrence_weekly') {
			
			var lblAnzeige = Ext.create('Ext.form.field.Display', {
				border : 0,
				width:200,
				height:18
			});
			var sID=""+id;
			var sName=""+col.name;
			var lblFunction = function (btn)
			{
				var fMo=multiEditorWindow[sID].editControls[sName + '_MOControl'].pressed;
				var fDi=multiEditorWindow[sID].editControls[sName + '_DIControl'].pressed;
				var fMi=multiEditorWindow[sID].editControls[sName + '_MIControl'].pressed;
				var fDo=multiEditorWindow[sID].editControls[sName + '_DOControl'].pressed;
				var fFr=multiEditorWindow[sID].editControls[sName + '_FRControl'].pressed;
				var fSa=multiEditorWindow[sID].editControls[sName + '_SAControl'].pressed;
				var fSo=multiEditorWindow[sID].editControls[sName + '_SOControl'].pressed;
				var sText="";
				var sSingular="";
				var iCount=0;
				if (fMo) {
					iCount++;
					sText+='MO, ';
					sSingular="Montags";
				}
				
				if (fDi) {
					iCount++;
					sText+='DI, ';
					sSingular="Dienstags";					
				}
				
				if (fMi) {
					iCount++;
					sText+='MI, ';
					sSingular="Mittwochs";					
				}
				
				if (fDo) {
					iCount++;
					sText+='DO, ';
					sSingular="Donnerstags";				
				}
				
				if (fFr) {
					iCount++;
					sText+='FR, ';
					sSingular="Freitags";					
				}
				
				if (fSa) {
					iCount++;
					sText+='SA, ';
					sSingular="Samstags";				
				}
				
				if (fSo) {
					iCount++;
					sText+='SO, ';
					sSingular="Sonntags";					
				}
				
				if (iCount==2)
					if (fSa)
						if (fSo) {
							sText="an Wochenende, ";
						}
				if (iCount==5)
					if (!fSa)
						if (!fSo) {
							sText="an Werktagen, ";
							sSingular="";
						}
				if (iCount==7) {
					sText="t&auml;glich, ";
					sSingular="";
				}
				if (iCount==0)
					lblAnzeige.setValue('(<span style="color:#ff0000;">keine Wochentage ausgew&auml;hlt</span>)');
				else
				if (iCount==1)
					lblAnzeige.setValue("("+sSingular+")");
				else
					lblAnzeige.setValue("("+sText.substring(0,sText.length-2)+")");
			
			}
			var oButtonPanel = Ext.create('Ext.form.FieldContainer', {
				name : 'edit_' + col.name,
				fieldLabel : col.title,
				labelWidth : 80,
				border : 1,
				layout : 'column'
			});
			var oControlMO = Ext.create('Ext.button.Button', {
				name : 'edit_MO' + col.name,
				width : 26,
				margin : '0 3 0 0',
				text : "MO",
				enableToggle : true,
				listeners: {toggle:lblFunction}
			});
			var oControlDI = Ext.create('Ext.button.Button', {
				name : 'edit_DI' + col.name,
				width : 26,
				margin : '0 3 0 0',
				text : "DI",
				enableToggle : true,
				listeners: {toggle:lblFunction}
			});
			var oControlMI = Ext.create('Ext.button.Button', {
				name : 'edit_MI' + col.name,
				width : 26,
				margin : '0 3 0 0',
				text : "MI",
				enableToggle : true,
				listeners: {toggle:lblFunction}
			});
			var oControlDO = Ext.create('Ext.button.Button', {
				name : 'edit_DO' + col.name,
				width : 26,
				margin : '0 3 0 0',
				text : "DO",
				enableToggle : true,
				listeners: {toggle:lblFunction}
			});
			var oControlFR = Ext.create('Ext.button.Button', {
				name : 'edit_FR' + col.name,
				width : 26,
				margin : '0 3 0 0',
				text : "FR",
				enableToggle : true,
				listeners: {toggle:lblFunction}
			});
			var oControlSA = Ext.create('Ext.button.Button', {
				name : 'edit_SA' + col.name,
				width : 26,
				margin : '0 3 0 0',
				text : "SA",
				enableToggle : true,
				listeners: {toggle:lblFunction}
			});
			var oControlSO = Ext.create('Ext.button.Button', {
				name : 'edit_SO' + col.name,
				width : 26,
				margin : '0 3 0 0',
				text : "SO",
				enableToggle : true,
				listeners: {toggle:lblFunction}
			});

			oButtonPanel.add(oControlMO);
			oButtonPanel.add(oControlDI);
			oButtonPanel.add(oControlMI);
			oButtonPanel.add(oControlDO);
			oButtonPanel.add(oControlFR);
			oButtonPanel.add(oControlSA);
			oButtonPanel.add(oControlSO);
			oButtonPanel.add(lblAnzeige);
			editorPanel.add(oButtonPanel);

			multiEditorWindow[id].editControls[col.name + '_anzeige'] = lblAnzeige;
			multiEditorWindow[id].editControls[col.name + '_MOControl'] = oControlMO;
			multiEditorWindow[id].editControls[col.name + '_DIControl'] = oControlDI;
			multiEditorWindow[id].editControls[col.name + '_MIControl'] = oControlMI;
			multiEditorWindow[id].editControls[col.name + '_DOControl'] = oControlDO;
			multiEditorWindow[id].editControls[col.name + '_FRControl'] = oControlFR;
			multiEditorWindow[id].editControls[col.name + '_SAControl'] = oControlSA;
			multiEditorWindow[id].editControls[col.name + '_SOControl'] = oControlSO;

			multiEditorWindow[id].editControls[col.name] = oButtonPanel;
			iHeight += 27;
		} else if (col.type == 'time_with_random') {
			var oDatePanel = Ext.create('Ext.form.FieldContainer', {
				name : 'edit_' + col.name,
				fieldLabel : col.title,
				labelWidth : 80,
				border : 1,
				layout : 'column'
			});

			var oDeltaCylcer= Ext.create('Ext.button.Cycle', {
				margin : '0 5 0 0',
				menu : {
					items : [ {
						checked : true,
						itemId : 'chk-before',
						text : 'fr&uuml;her'
					}, {
						itemId : 'chk-after',
						text : 'sp&auml;ter'

					} ]
				},
				showText : true,
				width : 100,
				hidden:true
			});

			var sName="" + col.name;
			
			
			var oCycleItems=[ {
				checked : true,
				itemId : 'chk-time',
				text : 'Uhrzeit'
			}, {
				itemId : 'chk-sunrise',
				text : 'Sonnenaufgang'

			} , {
				itemId : 'chk-sunset',
				text : 'Sonnenuntergang'

			} ]
			if (col.additionalTimeRef!=null)
			{
				for (var kIndex=0;kIndex<col.additionalTimeRef.length;kIndex++) {
					oCycleItems.push({
						itemId: col.additionalTimeRef[kIndex].name,
						text:   col.additionalTimeRef[kIndex].label
					});
				}
			}
						
			var oDateTypeCylcer;
			
			if (oCycleItems.length>3)
			{
				
				
				var dateTypeCycleStore = Ext.create('Ext.data.Store', {
				    fields: ['itemId', 'text'],
				    data : oCycleItems
				});
				
				oDateTypeCylcer = Ext.create('Ext.form.ComboBox', {
					store: dateTypeCycleStore,
					margin : '0 5 0 0',
					width : 150,
					queryMode: 'local',
					displayField: 'text',
					valueField: 'itemId',
					listeners : {
						change : function(field,value) {							
							multiEditorWindow[id].editControls[field.baseColName + '_deltaControl'].setVisible(value != 'chk-time');
							multiEditorWindow[id].editControls[field.baseColName + '_hourControl'].setValue((value != 'chk-time')?0:12);
							multiEditorWindow[id].editControls[field.baseColName + '_minuteControl'].setValue(0);
							var pCol = [];
							for ( var kIndex = 0; kIndex < columnDef.length; kIndex++)
								if (columnDef[kIndex].id == id)
									pCol = columnDef[kIndex].columns;
							for (var kIndex=0;kIndex<pCol.length;kIndex++)
								if (pCol[kIndex].name==field.baseColName)
									if (pCol[kIndex].additionalTimeRef!=null)
									{
										var addTimeRef=pCol[kIndex].additionalTimeRef;
										var oDisturbedControl=[];
										var oDisabledControl=[];
										for (var lIndex=0;lIndex<addTimeRef.length;lIndex++)
										{
											if (addTimeRef[lIndex].disableControl!=null) {
												for (var pIndex=0;pIndex<addTimeRef[lIndex].disableControl.length;pIndex++)
													oDisturbedControl.push(addTimeRef[lIndex].disableControl[pIndex]);
												if (addTimeRef[lIndex].name==value)
													for (var pIndex=0;pIndex<addTimeRef[lIndex].disableControl.length;pIndex++)
														oDisabledControl.push(addTimeRef[lIndex].disableControl[pIndex]);
											}
										}
										if (oDisturbedControl.length>0)
										{
											for (var lIndex=0;lIndex<oDisturbedControl.length;lIndex++)
											{
												var fEnabled=true;
												for (var pIndex=0;pIndex<oDisabledControl.length;pIndex++)
													if (oDisabledControl[pIndex]==oDisturbedControl[lIndex])
														fEnabled=false;
												enableEditControl(id,oDisturbedControl[lIndex],fEnabled);
											}
										}
									}
						}
					}
				});	
				oDateTypeCylcer.baseColName=sName;
			} else {
				oDateTypeCylcer = Ext.create('Ext.button.Cycle', {
					margin : '0 5 0 0',
					menu : {
						items : oCycleItems
					},
					showText : true,
					width : 150,
					listeners : {
						change : function(cycle, item, options) {							
							multiEditorWindow[id].editControls[cycle.baseColName + '_deltaControl'].setVisible(item.itemId != 'chk-time');
							multiEditorWindow[id].editControls[cycle.baseColName + '_hourControl'].setValue((item.itemId != 'chk-time')?0:12);
							multiEditorWindow[id].editControls[cycle.baseColName + '_minuteControl'].setValue(0);							
						}
					}
				});	
				oDateTypeCylcer.baseColName=sName;
			}
			
			
			
			var oControlHour = Ext.create('Ext.form.field.Number', {
				name : 'edit_Hour' + col.name,
				allowBlank : false,
				width : 43,
				margin : '0 5 0 0',
				step : 1,
				value : 0,
				minValue : 0,
				maxValue : 23,
				blankText : col.title + ' muss ausgef&uuml;llt werden',
				invalidText : col.title + ' muss ausgef&uuml;llt werden'
			});
			var oControlMinute = Ext.create('Ext.form.field.Number', {
				name : 'edit_Minute' + col.name,
				width : 43,
				allowBlank : false,
				margin : '0 5 0 0',
				value : 0,
				minValue : 0,
				maxValue : 59,
				blankText : col.title + ' muss ausgef&uuml;llt werden',
				invalidText : col.title + ' muss ausgef&uuml;llt werden'
			});			
			var oControlRandom = Ext
					.create(
							'Ext.form.field.Checkbox',
							{	labelWidth:80,
								labelSeparator:'',
								fieldLabel:'&nbsp;',
								boxLabel : 'Zeit zuf&auml;llig um &plusmn;15 Minuten variieren.'
							});

			oDatePanel.add(oDateTypeCylcer);
			oDatePanel.add(oControlHour);
			oDatePanel.add(oControlMinute);			
			oDatePanel.add(oDeltaCylcer);
			
			editorPanel.add(oDatePanel);
			editorPanel.add(oControlRandom);
			
			multiEditorWindow[id].editControls[col.name + '_dateTypeControl'] = oDateTypeCylcer;
			multiEditorWindow[id].editControls[col.name + '_deltaControl'] = oDeltaCylcer;
			multiEditorWindow[id].editControls[col.name + '_hourControl'] = oControlHour;
			multiEditorWindow[id].editControls[col.name + '_minuteControl'] = oControlMinute;
			multiEditorWindow[id].editControls[col.name + '_randomControl'] = oControlRandom;
			multiEditorWindow[id].editControls[col.name] = oDatePanel;
			iHeight += 27;

		} else if (col.type == 'datetime') {
			var oDatePanel = Ext.create('Ext.form.FieldContainer', {
				name : 'edit_' + col.name,
				fieldLabel : col.title,
				labelWidth : 80,
				border : 1,
				layout : 'column'
			});
			var oControlDate = Ext.create('Ext.form.field.Date', {
				name : 'edit_Date' + col.name,
				allowBlank : false,
				format : 'd.m.Y',
				width : 91,
				margin : '0 10 0 0',
				blankText : col.title + ' muss ausgef&uuml;llt werden',
				invalidText : col.title + ' muss ausgef&uuml;llt werden'
			});

			var oControlHour = Ext.create('Ext.form.field.Number', {
				name : 'edit_Hour' + col.name,
				allowBlank : false,
				fieldLabel : 'Uhrzeit',
				width : 91,
				labelWidth : 41,
				margin : '0 5 0 0',
				step : 1,
				value : 0,
				minValue : 0,
				maxValue : 23,
				blankText : col.title + ' muss ausgef&uuml;llt werden',
				invalidText : col.title + ' muss ausgef&uuml;llt werden'
			});
			var oControlMinute = Ext.create('Ext.form.field.Number', {
				name : 'edit_Minute' + col.name,
				width : 43,
				allowBlank : false,
				value : 0,
				margin : '0 5 0 0',
				minValue : 0,
				maxValue : 59,
				blankText : col.title + ' muss ausgef&uuml;llt werden',
				invalidText : col.title + ' muss ausgef&uuml;llt werden'
			});

			oDatePanel.add(oControlDate);
			oDatePanel.add(oControlHour);
			oDatePanel.add(oControlMinute);
			oDatePanel.add(Ext.create('Ext.form.Label', {
				text : '(hh:mm)',
				align : 'middle',
				margin : '3 0 0 0'
			}));
			editorPanel.add(oDatePanel);
			multiEditorWindow[id].editControls[col.name + '_dateControl'] = oControlDate;
			multiEditorWindow[id].editControls[col.name + '_hourControl'] = oControlHour;
			multiEditorWindow[id].editControls[col.name + '_minuteControl'] = oControlMinute;
			multiEditorWindow[id].editControls[col.name] = oDatePanel;
			iHeight += 27;
		} else if (col.type == 'trigger') {

			var oControlZoneCombo = Ext.create('Ext.form.field.ComboBox', {
				fieldLabel : 'Raum',
				store : getZoneStore(),
				queryMode : 'local',
				displayField : 'name',
				valueField : 'ZoneID',
				labelWidth : 68,
				allowBlank : false,
				blankText : 'Ein Raum muss gew&auml;hlt werden',
				invalidText : 'Ein Raum muss gew&auml;hlt werden',
				listConfig : {
					maxHeight : 300
				},
				editable : false
			});

			var oGroupStore = Ext.create('Ext.data.Store', {
				fields : [ 'group', 'name', 'icon' ],
				proxy : {
					type : 'memory',
					reader : {
						type : 'json',
						root : 'items'
					}
				}
			});

			var tplGroup = new Ext.XTemplate('<img src="{icon}"> {name}');

			var oControlGroupCombo = Ext.create('Ext.form.field.ComboBox', {
				fieldLabel : 'Gruppe',
				store : oGroupStore,
				queryMode : 'local',
				listConfig : {
					getInnerTpl : function() {
						return '<div><img src="{icon}"> {name}</div>';
					},
					maxHeight : 300
				},
				valueField : 'group',
				labelWidth : 68,
				displayField : 'name',
				disabled : true,
				forceSelection : true,
				editable : false,
				allowBlank : false,
				blankText : 'Eine Gruppe muss gew&auml;hlt werden',
				invalidText : 'Eine Gruppe muss gew&auml;hlt werden'
			});

			var oSceneStore = Ext.create('Ext.data.Store', {
				fields : [ 'id', 'name', 'reachable', 'icon' ],
				proxy : {
					type : 'memory',
					reader : {
						type : 'json',
						root : 'items'
					}
				}
			});

			var oControlSceneCombo = Ext.create('Ext.form.field.ComboBox', {
				fieldLabel : 'Aktivit&auml;t',
				store : oSceneStore,
				queryMode : 'local',
				displayField : 'name',
				valueField : 'id',
				labelWidth : 68,
				tpl : '<div><img src="{icon}"> {name}</div>',
				listConfig : {
					getInnerTpl : function() {
						return '<div><img src="{icon}"> {name}</div>';
					},
					maxHeight : 300
				},
				disabled : true,
				allowBlank : false,
				blankText : 'Eine Aktivit&auml;t muss gew&auml;hlt werden',
				invalidText : 'Eine Aktivit&auml;t muss gew&auml;hlt werden',
				editable : false
			});

			var oControlCheckAll = Ext.create('Ext.form.field.Checkbox', {
				boxLabel : 'alle Gruppen/Aktivit&auml;ten anzeigen'
			});

			var targetPanel = Ext.create('Ext.form.Panel', {
				height : 50,
				columnWidth : 0.5,
				border : 0,
				items : [ oControlZoneCombo, oControlGroupCombo ]
			});

			var actionPanel = Ext.create('Ext.form.Panel', {
				height : 50,
				columnWidth : 0.5,
				border : 0,
				items : [ oControlSceneCombo, oControlCheckAll ]
			});

			multiEditorWindow[id].editControls[col.name + '_zoneCombo'] = oControlZoneCombo;
			multiEditorWindow[id].editControls[col.name + '_groupCombo'] = oControlGroupCombo;
			multiEditorWindow[id].editControls[col.name + '_sceneCombo'] = oControlSceneCombo;
			multiEditorWindow[id].editControls[col.name + '_checkAll'] = oControlCheckAll;

			oControlZoneCombo.on('select', onSetZoneBox, oControlZoneCombo, {
				zoneBox : oControlZoneCombo,
				groupBox : oControlGroupCombo,
				sceneBox : oControlSceneCombo,
				checkBox : oControlCheckAll
			});

			oControlGroupCombo.on('select', onSetGroupBox, oControlGroupCombo,
					{
						zoneBox : oControlZoneCombo,
						groupBox : oControlGroupCombo,
						sceneBox : oControlSceneCombo,
						checkBox : oControlCheckAll
					});

			oControlSceneCombo.on('select', function(field, value, options) {
				var bg = 'background:none;';
				var icon = (value.length > 0 ? value[0].get('icon') : null);
				if (icon) {
					bg = "background:left center no-repeat url('" + icon
							+ "');";
				}
				field.setFieldStyle(bg + 'padding-left:21px;');
			});

			oControlCheckAll.on('change', function(field, newValue, oldValue,
					ComboControls) {
				var ZoneID = ComboControls.zoneBox.getValue();
				var GroupID = ComboControls.groupBox.getValue();
				var fShouldBeFiltered = !oControlCheckAll.getValue();

				var oGroupStore = getGroupStore(ZoneID);
				var oGroupControlStore = ComboControls.groupBox.store;
				oGroupControlStore.removeAll();
				oGroupStore.each(function(record) {
					var oNewRecord = record.copy()
					if (oNewRecord.get('reachable') || (!fShouldBeFiltered))
						oGroupControlStore.add(oNewRecord);
				});

				var oSceneStore = getSceneStore(ZoneID, GroupID);
				var oSceneControlStore = ComboControls.sceneBox.store;
				oSceneControlStore.removeAll();
				oSceneStore.each(function(record) {
					var oNewRecord = record.copy();
					if (oNewRecord.get('reachable') || (!fShouldBeFiltered))
						oSceneControlStore.add(oNewRecord);
				});
				ComboControls.sceneBox.createPicker();
			}, oControlGroupCombo, {
				zoneBox : oControlZoneCombo,
				groupBox : oControlGroupCombo,
				sceneBox : oControlSceneCombo,
				checkBox : oControlCheckAll
			});

			var oControlGroup = Ext.create('Ext.form.FieldSet', {
				title : 'Ausl&ouml;sende Aktivit&auml;t',
				width : 500,
				height : 90,
				layout : 'column',
				border : 0,
				items : [ targetPanel, actionPanel ]
			});
			multiEditorWindow[id].editControls[col.name] = oControlGroup;
			editorPanel.add(oControlGroup);
			iHeight += 100;

		} else if (col.type == 'message') {
			var oControlGroup = Ext.create('Ext.form.FieldSet', {
				title : col.title,
				width : 500
			});
			var oControlRec = Ext.create('Ext.form.field.Text', {
				name : 'edit_' + col.name + '_receiver',
				fieldLabel : 'Empf&auml;nger',
				allowBlank : false,
				width : 450,
				labelWidth : 68,
				regex : /\b[A-Z0-9._%-]+@[A-Z0-9.-]+\.[A-Z]{2,4}\b/i,
				regexText : 'Die Emailadresse ist fehlerhaft',
				blankText : 'Die Emailadresse muss ausgef&uuml;llt werden',
				invalidText : 'Die Emailadresse muss ausgef&uuml;llt werden'
			});
			var oControlSubject = Ext.create('Ext.form.field.Text', {
				name : 'edit_' + col.name + '_subject',
				fieldLabel : 'Betreff',
				allowBlank : false,
				width : 450,
				labelWidth : 68,
				blankText : 'Betreff muss ausgef&uuml;llt werden',
				invalidText : 'Betreff muss ausgef&uuml;llt werden'
			});
			var oControlBody = Ext.create('Ext.form.field.TextArea', {
				name : 'edit_' + col.name + '_body',
				fieldLabel : 'Inhalt',
				allowBlank : false,
				width : 450,
				height : 60,
				labelWidth : 68,
				blankText : 'Inhalt muss ausgef&uuml;llt werden',
				invalidText : 'Inhalt muss ausgef&uuml;llt werden'
			});
			oControlGroup.add(oControlRec);
			oControlGroup.add(oControlSubject);
			oControlGroup.add(oControlBody);
			editorPanel.add(oControlGroup);
			multiEditorWindow[id].editControls[col.name] = oControlGroup;
			multiEditorWindow[id].editControls[col.name + '_receiver'] = oControlRec;
			multiEditorWindow[id].editControls[col.name + '_subject'] = oControlSubject;
			multiEditorWindow[id].editControls[col.name + '_body'] = oControlBody;
			iHeight += 166;
		}
	}

	multiEditorWindow[id].setHeight(iHeight);
	multiEditorWindow[id].show();
	multiEditorWindow[id].hide();
}

function changeActiveSelect(id)
{
	if (multiSelectedItem[id].get('disabled'))
		enableItem(id);
	else
		disableItem(id);
}

function buildGridPanel(panelDev) {

	var id = panelDev.id;
	var oActivateColumnDef = {
		id : 'col-status',
		header : 'Aktiv',
		dataIndex : 'disabled',
		renderer : function(disabled) {
			return '<input type="checkbox" onclick="changeActiveSelect(\''+id+'\');"'
					+ (!disabled ? ' checked="true" >' : '>');
		},
		resizable : false,
		hideable : false,
		width : 50
	};
	var oColumnDef = [];
	if (panelDev.noactivColumn == null)
		oColumnDef.push(oActivateColumnDef);
	else if (panelDev.noactivColumn == false)
		oColumnDef.push(oActivateColumnDef);

	if (panelDev.passiveColumn != null)
		multiPassiveColumn[id] = panelDev.passiveColumn;

	colDef = panelDev.columns;
	for ( var iIndex = 0; iIndex < colDef.length; iIndex++) {
		var col = colDef[iIndex];
		if (col.type!="hidden") {
			var object = {
				id : 'col-' + col.name + '-' + id,
				header : col.title,
				dataIndex : col.name,
				hideable : false
			}
			if (col.renderfkt != null)
				object.renderer = col.renderfkt;
			else
				object.renderer = getDefaultRenderer(col);
			if (col.width != null)
				object.width = col.width;
			else
				object.flex = 1;
			oColumnDef.push(object);
		}
	}

	var storeName = 'appDataStore';
	if (id != null)
		storeName += "_" + id;

	var newEntry;
	if (typeof (baseValues.newEntry) == 'string')
		newEntry = baseValues.newEntry;
	else
		newEntry = baseValues.newEntry[id];

	var editEntry;
	if (typeof (baseValues.editEntry) == 'string')
		editEntry = baseValues.editEntry;
	else
		editEntry = baseValues.editEntry[id];

	var disableEntry;
	if (typeof (baseValues.disableEntry) == 'string')
		disableEntry = baseValues.disableEntry;
	else
		disableEntry = baseValues.disableEntry[id];

	var enableEntry;
	if (typeof (baseValues.enableEntry) == 'string')
		enableEntry = baseValues.enableEntry;
	else
		enableEntry = baseValues.enableEntry[id];

	var deleteEntry;
	if (typeof (baseValues.deleteEntry) == 'string')
		deleteEntry = baseValues.deleteEntry;
	else
		deleteEntry = baseValues.deleteEntry[id];

	var customEntry;
	if (typeof (baseValues.customEntry) == 'string')
		customEntry = baseValues.customEntry;
	else
		customEntry = baseValues.customEntry[id];
	
	var tbarDef = [];
	
	if (newEntry!="")
		tbarDef.push({
			text : newEntry,
			id : 'btn-add_' + id,
			iconCls : 'icon-add-action',
			handler : function() {
				newItem(id);
			}
		});
	if (editEntry!="")
		tbarDef.push({
			text : editEntry,
			id : 'btn-edit_' + id,
			iconCls : 'icon-edit-action',
			disabled : true,
			handler : function() {
				editItem(id);
			}
		});

	if (!(panelDev.noactivColumn == true)) {
		tbarDef.push({
			text : disableEntry,
			id : 'btn-disable_' + id,
			iconCls : 'icon-stop-action',
			disabled : true,
			handler : function() {
				disableItem(id);
			}
		});
		tbarDef.push({
			text : enableEntry,
			id : 'btn-enable_' + id,
			iconCls : 'icon-start-action',
			hidden : true,
			disabled : true,
			handler : function() {
				enableItem(id);
			}
		});
	}
	
	if (customEntry!=null)
	{
		for (var iIndex=0;iIndex<customEntry.length;iIndex++) 
			tbarDef.push({
				text : customEntry[iIndex].title,
				id : 'btn-custom_'+iIndex+'_' + id,
				icon : customEntry[iIndex].icon,
				handler : customEntry[iIndex].handler
			});
	}
	
	tbarDef.push('->');
	if (deleteEntry!="")
		tbarDef.push({
			text : deleteEntry,
			id : 'btn-delete_' + id,
			iconCls : 'icon-delete-action',
			disabled : true,
			handler : function() {
				deleteItem(id);
			}
		});
	var gridPanel = Ext.create('Ext.grid.Panel', {
		title : panelDev.name,
		store : Ext.data.StoreManager.lookup(storeName),
		autoScroll:true,
		scroll:'vertical',
		columns : oColumnDef,
		border : 0,
		enableColumnHide : false,
		viewConfig : {
			stripeRows : true
		},
		tbar : {
			items : tbarDef
		}
	});
	multiPanelArray[id]=gridPanel;

	gridPanel
			.on({
				selectionchange : function(view, selections, options) {
					if (selections.length > 0) {
						multiSelectedItem[id] = selections[0];

						var colDef = {};
						for ( var iIndex = 0; iIndex < columnDef.length; iIndex++)
							if (columnDef[iIndex].id == id)
								colDef = columnDef[iIndex];
						if (Ext.getCmp('btn-edit_' + id)!=null)
							Ext.getCmp('btn-edit_' + id).setDisabled(false);
						if (Ext.getCmp('btn-delete_' + id)!=null)
							Ext.getCmp('btn-delete_' + id).setDisabled(false);

						if (colDef.passiveColumn != null) {
							if (multiSelectedItem[id].get(colDef.passiveColumn) == true) {
								if (Ext.getCmp('btn-edit_' + id)!=null)
									Ext.getCmp('btn-edit_' + id).setDisabled(true);
								if (Ext.getCmp('btn-delete_' + id)!=null)
									Ext.getCmp('btn-delete_' + id).setDisabled(true);
							}
						}

						multiSelectedId[id] = multiSelectedItem[id].get('id');
						if (Ext.getCmp('btn-disable_' + id) != null)
							Ext.getCmp('btn-disable_' + id).setDisabled(
									multiSelectedItem[id].get('disabled'));
						if (Ext.getCmp('btn-enable_' + id) != null)
							Ext.getCmp('btn-enable_' + id).setDisabled(
									!multiSelectedItem[id].get('disabled'));
						if (Ext.getCmp('btn-disable_' + id) != null)
							Ext.getCmp('btn-disable_' + id).setVisible(
									!multiSelectedItem[id].get('disabled'));
						if (Ext.getCmp('btn-enable_' + id) != null)
							Ext.getCmp('btn-enable_' + id).setVisible(
									multiSelectedItem[id].get('disabled'));
					} else {
						multiSelectedItem[id] = null;
						multiSelectedId[id] = -1;
						if (Ext.getCmp('btn-edit_' + id)!=null)
							Ext.getCmp('btn-edit_' + id).setDisabled(true);
						if (Ext.getCmp('btn-disable_' + id) != null)
							Ext.getCmp('btn-disable_' + id).setDisabled(true);
						if (Ext.getCmp('btn-delete_' + id)!=null)
							Ext.getCmp('btn-delete_' + id).setDisabled(true);
						if (Ext.getCmp('btn-enable_' + id) != null)
							Ext.getCmp('btn-enable_' + id).setDisabled(true);
						if (Ext.getCmp('btn-enable_' + id) != null)
							Ext.getCmp('btn-enable_' + id).setVisible(false);
					}
				}
			});
	
	buildEditWindow(panelDev);
	return gridPanel;
}

// v2
function makeMultiPanel(tabDev, saveFunction, deleteFunction,checkMinimalVersion,saveSingleFunction) {

	columnDef = tabDev;
	saveCallback = saveFunction;
	deleteCallback = deleteFunction;
	saveSingleCallback=saveSingleFunction;
	var contentBereich = document.getElementById('myExtContent');

	if (checkMinimalVersion!=null) {
		var sMinimalCheck=checkMinimalVersion();
		if (sMinimalCheck!=true) {
			contentBereich.innerHTML="";
			basePanel = Ext.create('Ext.panel.Panel', {
				renderTo : contentBereich,		
				layout : {
					type : 'border'
				},
				height:contentBereich.clientHeight,
				html: sMinimalCheck
			});
			basePanel.setHeight(document.getElementById('myExtContent').clientHeight);
			return;
		}
	}
	
	var tabPanel = Ext.create('Ext.tab.Panel', {
		region : 'center',
		border : 0
	});
	for ( var iIndex = 0; iIndex < tabDev.length; iIndex++) {
		var tabDevObj = tabDev[iIndex];

		var panel;
		if (tabDevObj.type == 'simple') {
			panel = buildSimplePanel(tabDevObj);
		}
		if (tabDevObj.type == 'grid') {
			panel = buildGridPanel(tabDevObj);
		}

		if (panel != null)
			tabPanel.add(panel);
	}
	tabPanel.setActiveTab(0);
	contentBereich.innerHTML = "";
	basePanel = Ext.create('Ext.panel.Panel', {
		renderTo : contentBereich,
		layout : {
			type : 'border'
		},
		height : contentBereich.clientHeight,
		items : [ tabPanel, {
			region : 'south',
			title : 'Hilfe',
			xtype : 'panel',
			height : Math.floor(document.getElementById('myExtContent').clientHeight/2),
			minHeight : 200,
			layout : 'fit',
			collapsible : true,
			collapsed : true,
			split : true,
			html: ajaxSyncRequest(baseValues.helpText,{})
		// enable resizing
		} ]
	});
	Ext.EventManager
			.onWindowResize(function() {
				// pass "true" to get the contendWidth (excluding
				// border/padding/etc.)
				basePanel.setWidth(1);
				basePanel.setHeight(1);
				basePanel.setWidth(document.getElementById('myExtContent').clientWidth);
				basePanel.setHeight(document.getElementById('myExtContent').clientHeight);
				// seems to be no need to call mainPanel.doLayout() here in my
				// situation
			});

}

// v1
function makeBasePanel(colDef, saveFunction, deleteFunction,checkMinimalVersion,saveSingleFunction) {
	columnDef = colDef;
	saveCallback = saveFunction;
	deleteCallback = deleteFunction;
	saveSingleCallback=saveSingleFunction;
	var contentBereich = document.getElementById('myExtContent');

	if (checkMinimalVersion!=null) {
		var sMinimalCheck=checkMinimalVersion();
		if (sMinimalCheck!=true) {
			contentBereich.innerHTML="";
			basePanel = Ext.create('Ext.panel.Panel', {
				renderTo : contentBereich,		
				layout : {
					type : 'border'
				},
				height:contentBereich.clientHeight,
				html: sMinimalCheck
			});
			basePanel.setHeight(document.getElementById('myExtContent').clientHeight);
			return;
		}
	}
	
	
	var oColumnDef = [ {
		id : 'col-status',
		header : 'Aktiv',
		dataIndex : 'disabled',
		renderer : function(disabled) {
			return '<input type="checkbox" disabled="true"'
					+ (!disabled ? ' checked="true">' : '>');
		},
		resizable : false,
		hideable : false,
		width : 50
	} ];
	for ( var iIndex = 0; iIndex < colDef.length; iIndex++) {
		var col = colDef[iIndex];
		var object = {
			id : 'col-' + col.name,
			header : col.title,
			dataIndex : col.name,
			hideable : false,
			flex : 1
		}
		if (col.renderfkt != null)
			object.renderer = col.renderfkt;
		else
			object.renderer = getDefaultRenderer(col);
		oColumnDef.push(object);
	}

	var gridPanel = Ext.create('Ext.grid.Panel', {

		store : Ext.data.StoreManager.lookup('appDataStore'),
		columns : oColumnDef,
		region : 'center',
		border : 0,
		enableColumnHide : false,
		viewConfig : {
			stripeRows : true
		},
		tbar : {
			items : [ {
				text : baseValues.newEntry,
				id : 'btn-add',
				iconCls : 'icon-add-action',
				handler : newItem
			}, {
				text : baseValues.editEntry,
				id : 'btn-edit',
				iconCls : 'icon-edit-action',
				disabled : true,
				handler : editItem
			}, {
				text : baseValues.disableEntry,
				id : 'btn-disable',
				iconCls : 'icon-stop-action',
				disabled : true,
				handler : disableItem
			}, {
				text : baseValues.enableEntry,
				id : 'btn-enable',
				iconCls : 'icon-start-action',
				hidden : true,
				disabled : true,
				handler : enableItem
			}, '->', {
				text : baseValues.deleteEntry,
				id : 'btn-delete',
				iconCls : 'icon-delete-action',
				disabled : true,
				handler : deleteItem
			} ]
		}
	});
	gridPanel.on({
		selectionchange : function(view, selections, options) {
			if (selections.length > 0) {
				selectedItem = selections[0];
				selectedId = selectedItem.get('id');
				if (Ext.getCmp('btn-edit')!=null)
					Ext.getCmp('btn-edit').setDisabled(false);
				if (Ext.getCmp('btn-delete')!=null)
					Ext.getCmp('btn-delete').setDisabled(false);
				if (Ext.getCmp('btn-disable')!=null)
					Ext.getCmp('btn-disable').setDisabled(
							selectedItem.get('disabled'));
				if (Ext.getCmp('btn-enable')!=null)
					Ext.getCmp('btn-enable').setDisabled(
							!selectedItem.get('disabled'));
				if (Ext.getCmp('btn-disable')!=null)
					Ext.getCmp('btn-disable').setVisible(
							!selectedItem.get('disabled'));
				if (Ext.getCmp('btn-enable')!=null)
					Ext.getCmp('btn-enable').setVisible(
							selectedItem.get('disabled'));
			} else {
				selectedItem = null;
				selectedId = -1;
				if (Ext.getCmp('btn-edit')!=null)
					Ext.getCmp('btn-edit').setDisabled(true);
				if (Ext.getCmp('btn-disable')!=null)
					Ext.getCmp('btn-disable').setDisabled(true);
				if (Ext.getCmp('btn-delete')!=null)
					Ext.getCmp('btn-delete').setDisabled(true);
				if (Ext.getCmp('btn-enable')!=null)
					Ext.getCmp('btn-enable').setDisabled(true);
				if (Ext.getCmp('btn-enable')!=null)
					Ext.getCmp('btn-enable').setVisible(false);
			}
		}
	});
	contentBereich.innerHTML = "";
	basePanel = Ext.create('Ext.panel.Panel', {
		renderTo : contentBereich,

		layout : {
			type : 'border'
		},
		height : contentBereich.clientHeight,
		items : [ gridPanel, {
			region : 'south',
			title : 'Hilfe',
			xtype : 'panel',
			height : Math.floor(document.getElementById('myExtContent').clientHeight/2),
			minHeight : 200,
			layout : 'fit',
			collapsible : true,
			collapsed : true,
			split : true,
			html: ajaxSyncRequest(baseValues.helpText,{})
		// enable resizing
		} ]
	});
	Ext.EventManager
			.onWindowResize(function() {
				// pass "true" to get the contendWidth (excluding
				// border/padding/etc.)
				basePanel
						.setHeight(document.getElementById('myExtContent').clientHeight);
				// seems to be no need to call mainPanel.doLayout() here in my
				// situation
			});

	var editorPanel = Ext.create('Ext.form.Panel', {
		bodyPadding : 5,
		border : 0,
		buttons : [ {
			text : 'Abbruch',
			handler : function() {
				editorWindow.hide();
			}
		}, {
			text : 'Speichern',
			handler : function() {
				var fValid = true;
				for ( var sKey in editorWindow.editControls) {
					var oControl = editorWindow.editControls[sKey];

					if (oControl.isValid != null)
						if (!oControl.isValid())
							fValid = false;
				}
				if (fValid) {
					saveCallback(getObjectData());
					editorWindow.hide();
				}
			}
		} ]
	});

	editorWindow = Ext.create('Ext.window.Window', {
		closeAction : 'hide',
		title : baseValues.editorTitle,
		modal : true, // Exclusive input for the window
		width : 525,
		layout : 'fit',
		items : [ editorPanel ]
	});

	editorWindow.editControls = {};
	var iHeight = 75;
	for ( var iIndex = 0; iIndex < colDef.length; iIndex++) {
		var col = colDef[iIndex];
		if (col.type == 'string') {
			var oControl = Ext.create('Ext.form.field.Text', {
				name : 'edit_' + col.name,
				fieldLabel : col.title,
				allowBlank : false,
				width : 500,
				labelWidth : 80,
				blankText : col.title + ' muss ausgef&uuml;llt werden',
				invalidText : col.title + ' muss ausgef&uuml;llt werden'
			});
			editorPanel.add(oControl);
			editorWindow.editControls[col.name] = oControl;
			iHeight += 27;
		} else if (col.type == 'trigger') {

			var oControlZoneCombo = Ext.create('Ext.form.field.ComboBox', {
				fieldLabel : 'Raum',
				store : getZoneStore(),
				queryMode : 'local',
				displayField : 'name',
				valueField : 'ZoneID',
				labelWidth : 68,
				allowBlank : false,
				blankText : 'Ein Raum muss gew&auml;hlt werden',
				invalidText : 'Ein Raum muss gew&auml;hlt werden',
				listConfig : {
					maxHeight : 300
				},
				editable : false
			});

			var oGroupStore = Ext.create('Ext.data.Store', {
				fields : [ 'group', 'name', 'icon' ],
				proxy : {
					type : 'memory',
					reader : {
						type : 'json',
						root : 'items'
					}
				}
			});

			var tplGroup = new Ext.XTemplate('<img src="{icon}"> {name}');

			var oControlGroupCombo = Ext.create('Ext.form.field.ComboBox', {
				fieldLabel : 'Gruppe',
				store : oGroupStore,
				queryMode : 'local',
				listConfig : {
					getInnerTpl : function() {
						return '<div><img src="{icon}"> {name}</div>';
					},
					maxHeight : 300
				},
				valueField : 'group',
				labelWidth : 68,
				displayField : 'name',
				disabled : true,
				forceSelection : true,
				editable : false,
				allowBlank : false,
				blankText : 'Eine Gruppe muss gew&auml;hlt werden',
				invalidText : 'Eine Gruppe muss gew&auml;hlt werden'
			});

			var oSceneStore = Ext.create('Ext.data.Store', {
				fields : [ 'id', 'name', 'reachable', 'icon' ],
				proxy : {
					type : 'memory',
					reader : {
						type : 'json',
						root : 'items'
					}
				}
			});

			var oControlSceneCombo = Ext.create('Ext.form.field.ComboBox', {
				fieldLabel : 'Aktivit&auml;t',
				store : oSceneStore,
				queryMode : 'local',
				displayField : 'name',
				valueField : 'id',
				labelWidth : 68,
				tpl : '<div><img src="{icon}"> {name}</div>',
				listConfig : {
					getInnerTpl : function() {
						return '<div><img src="{icon}"> {name}</div>';
					},
					maxHeight : 300
				},
				disabled : true,
				allowBlank : false,
				blankText : 'Eine Aktivit&auml;t muss gew&auml;hlt werden',
				invalidText : 'Eine Aktivit&auml;t muss gew&auml;hlt werden',
				editable : false
			});

			var oControlCheckAll = Ext.create('Ext.form.field.Checkbox', {
				boxLabel : 'alle Gruppen/Aktivit&auml;ten anzeigen'
			});

			var targetPanel = Ext.create('Ext.form.Panel', {
				height : 50,
				columnWidth : 0.5,
				border : 0,
				items : [ oControlZoneCombo, oControlGroupCombo ]
			});

			var actionPanel = Ext.create('Ext.form.Panel', {
				height : 50,
				columnWidth : 0.5,
				border : 0,
				items : [ oControlSceneCombo, oControlCheckAll ]
			});

			editorWindow.editControls[col.name + '_zoneCombo'] = oControlZoneCombo;
			editorWindow.editControls[col.name + '_groupCombo'] = oControlGroupCombo;
			editorWindow.editControls[col.name + '_sceneCombo'] = oControlSceneCombo;
			editorWindow.editControls[col.name + '_checkAll'] = oControlCheckAll;

			oControlZoneCombo.on('select', onSetZoneBox, oControlZoneCombo, {
				zoneBox : oControlZoneCombo,
				groupBox : oControlGroupCombo,
				sceneBox : oControlSceneCombo,
				checkBox : oControlCheckAll
			});

			oControlGroupCombo.on('select', onSetGroupBox, oControlGroupCombo,
					{
						zoneBox : oControlZoneCombo,
						groupBox : oControlGroupCombo,
						sceneBox : oControlSceneCombo,
						checkBox : oControlCheckAll
					});

			oControlSceneCombo.on('select', function(field, value, options) {
				var bg = 'background:none;';
				var icon = (value.length > 0 ? value[0].get('icon') : null);
				if (icon) {
					bg = "background:left center no-repeat url('" + icon
							+ "');";
				}
				field.setFieldStyle(bg + 'padding-left:21px;');
			});

			oControlCheckAll.on('change', function(field, newValue, oldValue,
					ComboControls) {
				var ZoneID = ComboControls.zoneBox.getValue();
				var GroupID = ComboControls.groupBox.getValue();
				var fShouldBeFiltered = !oControlCheckAll.getValue();

				var oGroupStore = getGroupStore(ZoneID);
				var oGroupControlStore = ComboControls.groupBox.store;
				oGroupControlStore.removeAll();
				oGroupStore.each(function(record) {
					var oNewRecord = record.copy()
					if (oNewRecord.get('reachable') || (!fShouldBeFiltered))
						oGroupControlStore.add(oNewRecord);
				});

				var oSceneStore = getSceneStore(ZoneID, GroupID);
				var oSceneControlStore = ComboControls.sceneBox.store;
				oSceneControlStore.removeAll();
				oSceneStore.each(function(record) {
					var oNewRecord = record.copy();
					if (oNewRecord.get('reachable') || (!fShouldBeFiltered))
						oSceneControlStore.add(oNewRecord);
				});
				ComboControls.sceneBox.createPicker();
			}, oControlGroupCombo, {
				zoneBox : oControlZoneCombo,
				groupBox : oControlGroupCombo,
				sceneBox : oControlSceneCombo,
				checkBox : oControlCheckAll
			});

			var oControlGroup = Ext.create('Ext.form.FieldSet', {
				title : 'Ausl&ouml;sende Aktivit&auml;t',
				width : 500,
				height : 90,
				layout : 'column',
				border : 0,
				items : [ targetPanel, actionPanel ]
			});
			editorWindow.editControls[col.name] = oControlGroup;
			editorPanel.add(oControlGroup);
			iHeight += 100;

		} else if (col.type == 'message') {
			var oControlGroup = Ext.create('Ext.form.FieldSet', {
				title : col.title,
				width : 500
			});
			var oControlRec = Ext.create('Ext.form.field.Text', {
				name : 'edit_' + col.name + '_receiver',
				fieldLabel : 'Empf&auml;nger',
				allowBlank : false,
				width : 450,
				labelWidth : 68,
				regex : /\b[A-Z0-9._%-]+@[A-Z0-9.-]+\.[A-Z]{2,4}\b/i,
				regexText : 'Die Emailadresse ist fehlerhaft',
				blankText : 'Die Emailadresse muss ausgef&uuml;llt werden',
				invalidText : 'Die Emailadresse muss ausgef&uuml;llt werden'
			});
			var oControlSubject = Ext.create('Ext.form.field.Text', {
				name : 'edit_' + col.name + '_subject',
				fieldLabel : 'Betreff',
				allowBlank : false,
				width : 450,
				labelWidth : 68,
				blankText : 'Betreff muss ausgef&uuml;llt werden',
				invalidText : 'Betreff muss ausgef&uuml;llt werden'
			});
			var oControlBody = Ext.create('Ext.form.field.TextArea', {
				name : 'edit_' + col.name + '_body',
				fieldLabel : 'Inhalt',
				allowBlank : false,
				width : 450,
				height : 60,
				labelWidth : 68,
				blankText : 'Inhalt muss ausgef&uuml;llt werden',
				invalidText : 'Inhalt muss ausgef&uuml;llt werden'
			});
			oControlGroup.add(oControlRec);
			oControlGroup.add(oControlSubject);
			oControlGroup.add(oControlBody);
			editorPanel.add(oControlGroup);
			editorWindow.editControls[col.name] = oControlGroup;
			editorWindow.editControls[col.name + '_receiver'] = oControlRec;
			editorWindow.editControls[col.name + '_subject'] = oControlSubject;
			editorWindow.editControls[col.name + '_body'] = oControlBody;
			iHeight += 166;
		}
	}

	editorWindow.setHeight(iHeight);
	basePanel.setHeight(document.getElementById('myExtContent').clientHeight);
}

// v2
function onSetZoneBox(combo, records, ComboControls) {
	var ZoneID = ComboControls.zoneBox.getValue();

	var oGroupStore = getGroupStore(ZoneID);
	var oGroupControlStore = ComboControls.groupBox.store;
	var fShouldBeFiltered = !ComboControls.checkBox.getValue();
	oGroupControlStore.removeAll();
	oGroupStore.each(function(record) {
		var oNewRecord = record.copy()
		if (oNewRecord.get('reachable') || (!fShouldBeFiltered))
			oGroupControlStore.add(oNewRecord);
	});
	ComboControls.groupBox.setDisabled(false);
	ComboControls.groupBox.setValue(null);
	ComboControls.sceneBox.setDisabled(true);
	ComboControls.sceneBox.setValue(null);
	ComboControls.groupBox.setFieldStyle('background:none;');
	ComboControls.sceneBox.setFieldStyle('background:none;');
}

// v2
function onSetGroupBox(combo, records, ComboControls) {
	var ZoneID = ComboControls.zoneBox.getValue();
	var GroupID = ComboControls.groupBox.getValue();

	var oSceneStore = getSceneStore(ZoneID, GroupID);
	var oSceneControlStore = ComboControls.sceneBox.store;
	var fShouldBeFiltered = !ComboControls.checkBox.getValue();
	oSceneControlStore.removeAll();
	oSceneStore.each(function(record) {
		var oNewRecord = record.copy();
		if (oNewRecord.get('reachable') || (!fShouldBeFiltered))
			oSceneControlStore.add(oNewRecord);
	});
	ComboControls.sceneBox.setDisabled(false);
	ComboControls.sceneBox.setValue(null);
	if (combo != null)
		ComboControls.sceneBox.createPicker();

	var bg = 'background:none;';
	var icon = getImagePathForGroup(ZoneID, GroupID);
	if (icon) {
		bg = "background:left center no-repeat url('" + icon + "');";
	}
	ComboControls.groupBox.setFieldStyle(bg + 'padding-left:21px;');
	ComboControls.sceneBox.setFieldStyle('background:none;');
}

// v2
function getObjectData(id) {
	if (id == null) {
		var oNewObject = {};
		for ( var iIndex = 0; iIndex < columnDef.length; iIndex++) {
			var col = columnDef[iIndex];
			if (col.type == 'string') {
				var oTextControl = editorWindow.editControls[col.name];
				oNewObject[col.name] = oTextControl.getValue();
			} else if (col.type == 'trigger') {
				var oZoneControl = editorWindow.editControls[col.name
						+ '_zoneCombo'];
				var oGroupControl = editorWindow.editControls[col.name
						+ '_groupCombo'];
				var oSzeneControl = editorWindow.editControls[col.name
						+ '_sceneCombo'];
				oNewObject[col.name] = {
					'zone' : oZoneControl.getValue(),
					'group' : oGroupControl.getValue(),
					'scene' : oSzeneControl.getValue()
				}
			} else if (col.type == 'message') {
				var oControlRec = editorWindow.editControls[col.name
						+ '_receiver'];
				var oControlSubject = editorWindow.editControls[col.name
						+ '_subject'];
				var oControlBody = editorWindow.editControls[col.name + '_body'];
				oNewObject[col.name] = {
					messageType : "email",
					receiver : oControlRec.getValue(),
					subject : oControlSubject.getValue(),
					message : oControlBody.getValue()
				};
			}
		}
		if (selectedId == -1) {
			var iMaxID = 0;
			Ext.data.StoreManager.lookup('appDataStore').each(function(oRec) {
				if (iMaxID < oRec.get('id'))
					iMaxID = oRec.get('id');
			});
			oNewObject.id = iMaxID + 1;
			oNewObject.disabled = false;
		} else {
			oNewObject.id = selectedId;
			oNewObject.disabled = selectedItem.get("disabled");
		}

		return oNewObject;
	} else {

		var colDef = [];
		for ( var iIndex = 0; iIndex < columnDef.length; iIndex++)
			if (columnDef[iIndex].id == id)
				colDef = columnDef[iIndex].columns;
		
		var oNewObject = {};
		for ( var iIndex = 0; iIndex < colDef.length; iIndex++) {
			var col = colDef[iIndex];
			if (col.type == 'string') {
				var oTextControl = multiEditorWindow[id].editControls[col.name];
				oNewObject[col.name] = oTextControl.getValue();
			} else if (col.type == 'trigger') {
				var oZoneControl = multiEditorWindow[id].editControls[col.name
						+ '_zoneCombo'];
				var oGroupControl = multiEditorWindow[id].editControls[col.name
						+ '_groupCombo'];
				var oSzeneControl = multiEditorWindow[id].editControls[col.name
						+ '_sceneCombo'];
				oNewObject[col.name] = {
					'zone' : oZoneControl.getValue(),
					'group' : oGroupControl.getValue(),
					'scene' : oSzeneControl.getValue()
				}
			} else if (col.type == 'message') {
				var oControlRec = multiEditorWindow[id].editControls[col.name
						+ '_receiver'];
				var oControlSubject = multiEditorWindow[id].editControls[col.name
						+ '_subject'];
				var oControlBody = multiEditorWindow[id].editControls[col.name + '_body'];
				oNewObject[col.name] = {
					messageType : "email",
					receiver : oControlRec.getValue(),
					subject : oControlSubject.getValue(),
					message : oControlBody.getValue()
				};
			} else if (col.type == 'recurrence_weekly') {
				oNewObject[col.name] = [];
				
				if (multiEditorWindow[id].editControls[col.name + '_MOControl'].pressed)
					oNewObject[col.name].push('MO'); 
				if (multiEditorWindow[id].editControls[col.name + '_DIControl'].pressed)
					oNewObject[col.name].push('TU');
				if (multiEditorWindow[id].editControls[col.name + '_MIControl'].pressed)
					oNewObject[col.name].push('WE');
				if (multiEditorWindow[id].editControls[col.name + '_DOControl'].pressed)
					oNewObject[col.name].push('TH');
				if (multiEditorWindow[id].editControls[col.name + '_FRControl'].pressed)
					oNewObject[col.name].push('FR');
				if (multiEditorWindow[id].editControls[col.name + '_SAControl'].pressed)
					oNewObject[col.name].push('SA');
				if (multiEditorWindow[id].editControls[col.name + '_SOControl'].pressed)
					oNewObject[col.name].push('SU');

			} else if (col.type == 'time_with_random') {
				oNewObject[col.name]={};
				var sSelectedRef="";
				if (multiEditorWindow[id].editControls[col.name + '_dateTypeControl'].getXType()=="combobox") {					
					sSelectedRef=multiEditorWindow[id].editControls[col.name + '_dateTypeControl'].getValue();
				} else {
					sSelectedRef=multiEditorWindow[id].editControls[col.name + '_dateTypeControl'].getActiveItem().getItemId();
				}
				
				if (sSelectedRef=='chk-time') {
					var oDate=new Date();				
					oDate.setHours(multiEditorWindow[id].editControls[col.name + '_hourControl'].getValue());
					oDate.setMinutes(multiEditorWindow[id].editControls[col.name + '_minuteControl'].getValue());	
					oNewObject[col.name].start=Math.floor(oDate.getTime()/1000);
				} else {
					var iValue=multiEditorWindow[id].editControls[col.name + '_hourControl'].getValue()*3600;
					iValue+=multiEditorWindow[id].editControls[col.name + '_minuteControl'].getValue()*60;
					if (multiEditorWindow[id].editControls[col.name + '_deltaControl'].getActiveItem().getItemId()=='chk-before')
						iValue*=-1;					
					if (sSelectedRef=='chk-sunrise') {
						oNewObject[col.name].sunrise=iValue;
					} else
					if (sSelectedRef=='chk-sunset') {
						oNewObject[col.name].sunset=iValue;
					} else
						oNewObject[col.name][sSelectedRef]=iValue;
				}

				if (multiEditorWindow[id].editControls[col.name + '_randomControl'].getValue())
					oNewObject[col.name].maxdiv=1800;
			} else if (col.type == 'datetime') {
				var oDate=multiEditorWindow[id].editControls[col.name + '_dateControl'].getValue();
				oDate.setHours(multiEditorWindow[id].editControls[col.name + '_hourControl'].getValue());
				oDate.setMinutes(multiEditorWindow[id].editControls[col.name + '_minuteControl'].getValue());
				oNewObject[col.name] = Math.floor(oDate.getTime()/1000);
			} else if (col.type == 'action') {
				var gridStore = Ext.data.StoreManager.lookup('editWindowStore_'
						+ col.name + '_' + id);
				oNewObject[col.name] = [];
				gridStore.each(function(record)
				{
					var oObject={}
					if (record.get('zoneID')!=null)
						if (record.get('groupID')!=null)
							if (record.get('sceneID')!=null){
								oObject.zone=record.get('zoneID');
								oObject.group=record.get('groupID');
								oObject.scene=record.get('sceneID');
								oObject.delay=0;
								if (record.get('deltaTime')!=null)
									oObject.delay=record.get('deltaTime');
								oNewObject[col.name].push(oObject);
							}
				});				
			}
		}
		if (multiSelectedId[id] == -1) {
			var iMaxID = 0;

			Ext.data.StoreManager.lookup("appDataStore_" + id).each(
					function(oRec) {
						if (iMaxID < oRec.get('id'))
							iMaxID = oRec.get('id');
					});
			oNewObject.id = iMaxID + 1;
			oNewObject.disabled = false;
		} else {
			oNewObject.id = multiSelectedId[id];
			oNewObject.disabled = multiSelectedItem[id].get("disabled");
		}

		return oNewObject;
	}
}

// v2
function getObjectDataFromSelection(id) {
	if (id == null) {
		var oNewObject = {};
		for ( var iIndex = 0; iIndex < columnDef.length; iIndex++) {
			var col = columnDef[iIndex];
			var dataFragment = selectedItem.get(col.name);

			if (col.type == 'string') {
				oNewObject[col.name] = dataFragment
			} else if (col.type == 'trigger') {
				oNewObject[col.name] = {
					'zone' : dataFragment.zone,
					'group' : dataFragment.group,
					'scene' : dataFragment.scene
				}
			} else if (col.type == 'message') {
				oNewObject[col.name] = {
					messageType : "email",
					receiver : dataFragment.receiver,
					subject : dataFragment.subject,
					message : dataFragment.message
				};
			}
		}
		if (selectedId == -1) {
			var iMaxID = 0;
			Ext.data.StoreManager.lookup('appDataStore').each(function(oRec) {
				if (iMaxID < oRec.get('id'))
					iMaxID = oRec.get('id');
			});
			oNewObject.id = iMaxID + 1;
			oNewObject.disabled = false;
		} else {
			oNewObject.id = selectedId;
			oNewObject.disabled = selectedItem.get("disabled");
		}
		return oNewObject;
	} else {
		var colDef = [];
		for ( var iIndex = 0; iIndex < columnDef.length; iIndex++)
			if (columnDef[iIndex].id == id)
				colDef = columnDef[iIndex].columns;

		var oNewObject = {};
		for ( var iIndex = 0; iIndex < colDef.length; iIndex++) {
			var col = colDef[iIndex];
			var dataFragment = multiSelectedItem[id].get(col.name);

			if (col.type == 'string') {
				oNewObject[col.name] = dataFragment;
			} else if (col.type == 'trigger') {
				oNewObject[col.name] = {
					'zone' : dataFragment.zone,
					'group' : dataFragment.group,
					'scene' : dataFragment.scene
				}
			} else if (col.type == 'passive') {
				oNewObject[col.name] = dataFragment;
			} else if (col.type == 'hidden') {
				oNewObject[col.name] = dataFragment;
			} else if (col.type == 'message') {
				oNewObject[col.name] = {
					messageType : "email",
					receiver : dataFragment.receiver,
					subject : dataFragment.subject,
					message : dataFragment.message
				};
			} else if (col.type == 'recurrence_weekly') {
				oNewObject[col.name] = [];
				for ( var jIndex = 0; jIndex < dataFragment.length; jIndex++)
					oNewObject[col.name].push(dataFragment[jIndex]);

			} else if (col.type == 'time_with_random') {
				oNewObject[col.name] = {
					'maxdiv' : dataFragment.maxdiv
				}
				if (dataFragment.start!=null)
					oNewObject[col.name].start=dataFragment.start;
				else
				if (dataFragment.sunset!=null)
					oNewObject[col.name].sunset=dataFragment.sunset;
				else
				if (dataFragment.sunrise!=null)
					oNewObject[col.name].sunrise=dataFragment.sunrise;
				else
				if (col.additionalTimeRef!=null)
					for (var lIndex=0;lIndex<col.additionalTimeRef.length;lIndex++)
					{
						var objectName=col.additionalTimeRef[lIndex].name;
						if (dataFragment[objectName]!=null)
							oNewObject[col.name][objectName]=dataFragment[objectName];
					}
				
				
			} else if (col.type == 'datetime') {
				oNewObject[col.name] = dataFragment;
			} else if (col.type == 'action') {
				oNewObject[col.name] = [];
				for ( var jIndex = 0; jIndex < dataFragment.length; jIndex++) {
					var oNewSubobject = {};
					if (dataFragment[jIndex].delay != null)
						oNewSubobject.delay = dataFragment[jIndex].delay;
					if (dataFragment[jIndex].scene != null)
						oNewSubobject.scene = dataFragment[jIndex].scene;
					if (dataFragment[jIndex].zone != null)
						oNewSubobject.zone = dataFragment[jIndex].zone;
					if (dataFragment[jIndex].group != null)
						oNewSubobject.group = dataFragment[jIndex].group;
					if (dataFragment[jIndex].outputValue != null)
						oNewSubobject.outputValue = dataFragment[jIndex].outputValue;
					if (dataFragment[jIndex].device != null)
						oNewSubobject.device = dataFragment[jIndex].device;
					oNewObject[col.name].push(oNewSubobject);
				}
			}

		}
		if (multiSelectedId[id] == -1) {
			var iMaxID = 0;

			Ext.data.StoreManager.lookup("appDataStore_" + id).each(
					function(oRec) {
						if (iMaxID < oRec.get('id'))
							iMaxID = oRec.get('id');
					});
			oNewObject.id = iMaxID + 1;
			oNewObject.disabled = false;
		} else {
			oNewObject.id = multiSelectedId[id];
			oNewObject.disabled = multiSelectedItem[id].get("disabled");
		}
		return oNewObject;
	}
}

// v2
function setObjectData(oData, id) {
	if (id == null) {
		for ( var iIndex = 0; iIndex < columnDef.length; iIndex++) {
			var col = columnDef[iIndex];
			var dataFragment = oData.get(col.name);
			if (col.type == 'string') {
				var oTextControl = editorWindow.editControls[col.name];
				oTextControl.setValue(dataFragment);
			} else if (col.type == 'trigger') {
				var oZoneControl = editorWindow.editControls[col.name
						+ '_zoneCombo'];
				var oGroupControlr = editorWindow.editControls[col.name
						+ '_groupCombo'];
				var oSzeneControl = editorWindow.editControls[col.name
						+ '_sceneCombo'];
				var oCheckControl = editorWindow.editControls[col.name
						+ '_checkAll'];
				var Scenes = getScenes(dataFragment.zone, dataFragment.group);
				for ( var jIndex = 0; jIndex < Scenes.length; jIndex++)
					if (Scenes[jIndex].id == dataFragment.scene) {
						oCheckControl.setRawValue(!Scenes[jIndex].reachable);
					}

				oZoneControl.setValue(dataFragment.zone);
				onSetZoneBox(null, null,
						{
							zoneBox : oZoneControl,
							groupBox : oGroupControl,
							sceneBox : oSzeneControl,
							checkBox : editorWindow.editControls[col.name
									+ '_checkAll']
						});
				oGroupControl.setValue(dataFragment.group);

				onSetGroupBox(null, null,
						{
							zoneBox : oZoneControl,
							groupBox : oGroupControl,
							sceneBox : oSzeneControl,
							checkBox : editorWindow.editControls[col.name
									+ '_checkAll']
						});

				oSzeneControl.setValue(dataFragment.scene);
				var bg = 'background:none;';
				var icon = getImagePathForScene(dataFragment.zone,
						dataFragment.group, dataFragment.scene);
				if (icon) {
					bg = "background:left center no-repeat url('" + icon
							+ "');";
				}
				oSzeneControl.setFieldStyle(bg + 'padding-left:21px;');
			} else if (col.type == 'message') {
				var oControlRec = editorWindow.editControls[col.name
						+ '_receiver'];
				var oControlSubject = editorWindow.editControls[col.name
						+ '_subject'];
				var oControlBody = editorWindow.editControls[col.name + '_body'];
				oControlRec.setValue(dataFragment.receiver);
				oControlSubject.setValue(dataFragment.subject);
				oControlBody.setValue(dataFragment.message);
			}
		}
	} else {
		var colDef = [];
		for ( var iIndex = 0; iIndex < columnDef.length; iIndex++)
			if (columnDef[iIndex].id == id)
				colDef = columnDef[iIndex].columns;

		for ( var iIndex = 0; iIndex < colDef.length; iIndex++) {
			var col = colDef[iIndex];
			var dataFragment = oData.get(col.name);

			if (col.type == 'string') {
				var oTextControl = multiEditorWindow[id].editControls[col.name];
				oTextControl.setValue(dataFragment);
			} else if (col.type == 'trigger') {
				var oZoneControl = editorWindow.editControls[col.name
						+ '_zoneCombo'];
				var oGroupControl = editorWindow.editControls[col.name
						+ '_groupCombo'];
				var oSzeneControl = editorWindow.editControls[col.name
						+ '_sceneCombo'];
				var oCheckControl = editorWindow.editControls[col.name
						+ '_checkAll'];
				var Scenes = getScenes(dataFragment.zone, dataFragment.group);
				for ( var jIndex = 0; jIndex < Scenes.length; jIndex++)
					if (Scenes[jIndex].id == dataFragment.scene) {
						oCheckControl.setRawValue(!Scenes[jIndex].reachable);
					}

				oZoneControl.setValue(dataFragment.zone);
				onSetZoneBox(null, null,
						{
							zoneBox : oZoneControl,
							groupBox : oGroupControl,
							sceneBox : oSzeneControl,
							checkBox : editorWindow.editControls[col.name
									+ '_checkAll']
						});
				oGroupControl.setValue(dataFragment.group);

				onSetGroupBox(null, null,
						{
							zoneBox : oZoneControl,
							groupBox : oGroupControl,
							sceneBox : oSzeneControl,
							checkBox : editorWindow.editControls[col.name
									+ '_checkAll']
						});

				oSzeneControl.setValue(dataFragment.scene);
				var bg = 'background:none;';
				var icon = getImagePathForScene(dataFragment.zone,
						dataFragment.group, dataFragment.scene);
				if (icon) {
					bg = "background:left center no-repeat url('" + icon
							+ "');";
				}
				oSzeneControl.setFieldStyle(bg + 'padding-left:21px;');

			} else if (col.type == 'message') {
				var oControlRec = editorWindow.editControls[col.name
						+ '_receiver'];
				var oControlSubject = editorWindow.editControls[col.name
						+ '_subject'];
				var oControlBody = editorWindow.editControls[col.name + '_body'];
				oControlRec.setValue(dataFragment.receiver);
				oControlSubject.setValue(dataFragment.subject);
				oControlBody.setValue(dataFragment.message);
			} else if (col.type == 'recurrence_weekly') {
				multiEditorWindow[id].editControls[col.name + '_MOControl']
						.toggle(false);
				multiEditorWindow[id].editControls[col.name + '_DIControl']
						.toggle(false);
				multiEditorWindow[id].editControls[col.name + '_MIControl']
						.toggle(false);
				multiEditorWindow[id].editControls[col.name + '_DOControl']
						.toggle(false);
				multiEditorWindow[id].editControls[col.name + '_FRControl']
						.toggle(false);
				multiEditorWindow[id].editControls[col.name + '_SAControl']
						.toggle(false);
				multiEditorWindow[id].editControls[col.name + '_SOControl']
						.toggle(false);
				for ( var jIndex = 0; jIndex < dataFragment.length; jIndex++) {
					if (dataFragment[jIndex] == 'MO')
						multiEditorWindow[id].editControls[col.name
								+ '_MOControl'].toggle(true);
					if (dataFragment[jIndex] == 'TU')
						multiEditorWindow[id].editControls[col.name
								+ '_DIControl'].toggle(true);
					if (dataFragment[jIndex] == 'WE')
						multiEditorWindow[id].editControls[col.name
								+ '_MIControl'].toggle(true);
					if (dataFragment[jIndex] == 'TH')
						multiEditorWindow[id].editControls[col.name
								+ '_DOControl'].toggle(true);
					if (dataFragment[jIndex] == 'FR')
						multiEditorWindow[id].editControls[col.name
								+ '_FRControl'].toggle(true);
					if (dataFragment[jIndex] == 'SA')
						multiEditorWindow[id].editControls[col.name
								+ '_SAControl'].toggle(true);
					if (dataFragment[jIndex] == 'SU')
						multiEditorWindow[id].editControls[col.name
								+ '_SOControl'].toggle(true);
				}
			} else if (col.type == 'time_with_random') {
				
				
				var sSelectedValue;
				
				
				if (dataFragment.start!=null) {
					var oDate = new Date(dataFragment.start * 1000);
					sSelectedValue='chk-time';
					
					if (multiEditorWindow[id].editControls[col.name + '_dateTypeControl'].getXType()=="combobox") {					
						multiEditorWindow[id].editControls[col.name + '_dateTypeControl'].setValue(sSelectedValue);
					} else {
						multiEditorWindow[id].editControls[col.name + '_dateTypeControl'].setActiveItem(sSelectedValue);
					}

					
					multiEditorWindow[id].editControls[col.name + '_hourControl']
							.setValue(oDate.getHours());
					multiEditorWindow[id].editControls[col.name + '_minuteControl']
							.setValue(oDate.getMinutes());
				} else {
					var iMinutes=0
					if (dataFragment.sunrise!=null) {
						iMinutes=Math.floor(dataFragment.sunrise/60);
						sSelectedValue="chk-sunrise";
					} else
					if (dataFragment.sunset!=null) {
						iMinutes=Math.floor(dataFragment.sunset/60);
						sSelectedValue="chk-sunset";
					} else 
					if (col.additionalTimeRef!=null)
					{
						for (var lIndex=0;lIndex<col.additionalTimeRef.length;lIndex++)
							if (dataFragment[col.additionalTimeRef[lIndex].name]!=null) {
								iMinutes=Math.floor(dataFragment[col.additionalTimeRef[lIndex].name]/60);
								sSelectedValue=col.additionalTimeRef[lIndex].name;
							}
					}

					if (multiEditorWindow[id].editControls[col.name + '_dateTypeControl'].getXType()=="combobox") {					
						multiEditorWindow[id].editControls[col.name + '_dateTypeControl'].setValue(sSelectedValue);
					} else {
						multiEditorWindow[id].editControls[col.name + '_dateTypeControl'].setActiveItem(sSelectedValue);
					}

					
					if (iMinutes<0)
						multiEditorWindow[id].editControls[col.name + '_deltaControl'].setActiveItem('chk-before');
					else
						multiEditorWindow[id].editControls[col.name + '_deltaControl'].setActiveItem('chk-after');
									
					multiEditorWindow[id].editControls[col.name + '_hourControl'].setValue(Math.floor(Math.abs(iMinutes)/60));
					multiEditorWindow[id].editControls[col.name + '_minuteControl'].setValue(Math.abs(iMinutes)%60);
				}

				
				multiEditorWindow[id].editControls[col.name + '_randomControl']
						.setValue(false);
				if (dataFragment.maxdiv != null)
					if (dataFragment.maxdiv > 0)
						multiEditorWindow[id].editControls[col.name
								+ '_randomControl'].setValue(true);
			} else if (col.type == 'datetime') {
				var oDate = new Date(dataFragment * 1000)
				multiEditorWindow[id].editControls[col.name + '_hourControl']
						.setValue(oDate.getHours());
				multiEditorWindow[id].editControls[col.name + '_minuteControl']
						.setValue(oDate.getMinutes());
				multiEditorWindow[id].editControls[col.name + '_dateControl']
						.setValue(oDate);
			} else if (col.type == 'action') {
				var gridPanel = multiEditorWindow[id].editControls[col.name];
				gridPanel.getSelectionModel().deselectAll();
				gridPanel.getSelectionModel().clearSelections();
				gridPanel.getSelectionModel().position=null;
				var store = gridPanel.getStore();
				store.removeAll();
				for ( var jIndex = 0; jIndex < dataFragment.length; jIndex++) {
					if (dataFragment[jIndex].delay == null)
						dataFragment[jIndex].delay = 0;
					store.add({
						'zoneID' : dataFragment[jIndex].zone,
						'groupID' : dataFragment[jIndex].group,
						'sceneID' : dataFragment[jIndex].scene,
						'deltaTime' : dataFragment[jIndex].delay
					});
				}
				store.add({
					'zoneID' : null,
					'groupID' : null,
					'sceneID' : null,
					'deltaTime' : 0
				});
			}

		}
	}
}

// v2
function newItem(id) {
	if (id == null) {
		selectedId = -1;

		for ( var iIndex = 0; iIndex < columnDef.length; iIndex++) {
			var col = columnDef[iIndex];
			if (col.type == 'string') {
				var oTextControl = editorWindow.editControls[col.name];
				oTextControl.setRawValue(null);
			} else if (col.type == 'trigger') {
				var oZoneControl = editorWindow.editControls[col.name
						+ '_zoneCombo'];
				var oGroupControl = editorWindow.editControls[col.name
						+ '_groupCombo'];
				var oSzeneControl = editorWindow.editControls[col.name
						+ '_sceneCombo'];
				var oCheckControl = editorWindow.editControls[col.name
						+ '_checkAll'];
				oCheckControl.setRawValue(false);

				oZoneControl.setRawValue(null);
				oGroupControl.setRawValue(null);
				oSzeneControl.setRawValue(null);
				var bg = 'background:none;';
				oSzeneControl.setFieldStyle(bg + 'padding-left:21px;');
				oGroupControl.setFieldStyle(bg + 'padding-left:21px;');

			} else if (col.type == 'message') {
				var oControlRec = editorWindow.editControls[col.name
						+ '_receiver'];
				var oControlSubject = editorWindow.editControls[col.name
						+ '_subject'];
				var oControlBody = editorWindow.editControls[col.name + '_body'];
				oControlRec.setRawValue(null);
				oControlSubject.setRawValue(null);
				oControlBody.setRawValue(null);
			}
		}

		editorWindow.show();
		return;

	} else {
		multiSelectedId[id] = -1;
		var colDef = [];
		for ( var iIndex = 0; iIndex < columnDef.length; iIndex++)
			if (columnDef[iIndex].id == id)
				colDef = columnDef[iIndex].columns;

		for ( var iIndex = 0; iIndex < colDef.length; iIndex++) {
			var col = colDef[iIndex];
			if (col.type == 'string') {
				var oTextControl = multiEditorWindow[id].editControls[col.name];
				oTextControl.setRawValue(null);
				if (col.defaultValue!=null)
					oTextControl.setRawValue(col.defaultValue);
			} else if (col.type == 'trigger') {
				var oZoneControl = multiEditorWindow[id].editControls[col.name
						+ '_zoneCombo'];
				var oGroupControl = multiEditorWindow[id].editControls[col.name
						+ '_groupCombo'];
				var oSzeneControl = multiEditorWindow[id].editControls[col.name
						+ '_sceneCombo'];
				var oCheckControl = multiEditorWindow[id].editControls[col.name
						+ '_checkAll'];
				oCheckControl.setRawValue(false);

				oZoneControl.setRawValue(null);
				oGroupControl.setRawValue(null);
				oSzeneControl.setRawValue(null);
				var bg = 'background:none;';
				oSzeneControl.setFieldStyle(bg + 'padding-left:21px;');
				oGroupControl.setFieldStyle(bg + 'padding-left:21px;');

			} else if (col.type == 'message') {
				var oControlRec = multiEditorWindow[id].editControls[col.name
						+ '_receiver'];
				var oControlSubject = multiEditorWindow[id].editControls[col.name
						+ '_subject'];
				var oControlBody = multiEditorWindow[id].editControls[col.name
						+ '_body'];
				oControlRec.setRawValue(null);
				oControlSubject.setRawValue(null);
				oControlBody.setRawValue(null);
			} else if (col.type == 'recurrence_weekly') {
				multiEditorWindow[id].editControls[col.name + '_MOControl']
						.toggle(true);
				multiEditorWindow[id].editControls[col.name + '_DIControl']
						.toggle(true);
				multiEditorWindow[id].editControls[col.name + '_MIControl']
						.toggle(true);
				multiEditorWindow[id].editControls[col.name + '_DOControl']
						.toggle(true);
				multiEditorWindow[id].editControls[col.name + '_FRControl']
						.toggle(true);
				multiEditorWindow[id].editControls[col.name + '_SAControl']
						.toggle(true);
				multiEditorWindow[id].editControls[col.name + '_SOControl']
						.toggle(true);
				
			} else if (col.type == 'time_with_random') {

				if (multiEditorWindow[id].editControls[col.name + '_dateTypeControl'].getXType()=="combobox") {					
					multiEditorWindow[id].editControls[col.name + '_dateTypeControl'].setValue("chk-time");
				} else {
					multiEditorWindow[id].editControls[col.name + '_dateTypeControl'].setActiveItem("chk-time");
				}

				
				multiEditorWindow[id].editControls[col.name + '_hourControl']
						.setRawValue(null);
				multiEditorWindow[id].editControls[col.name + '_minuteControl']
						.setRawValue(null);
				multiEditorWindow[id].editControls[col.name + '_randomControl']
						.setRawValue(null);
				if (col.defaultValue!=null) {				
					var oDate = new Date(col.defaultValue* 1000);
					multiEditorWindow[id].editControls[col.name + '_hourControl']
							.setValue(oDate.getHours());
					multiEditorWindow[id].editControls[col.name + '_minuteControl']
							.setValue(oDate.getMinutes());
				}

				
				
			} else if (col.type == 'datetime') {
				multiEditorWindow[id].editControls[col.name + '_dateControl']
						.setRawValue(null);
				multiEditorWindow[id].editControls[col.name + '_hourControl']
						.setRawValue(12);
				multiEditorWindow[id].editControls[col.name + '_minuteControl']
						.setRawValue(0);
				if (col.defaultValue!=null) {				
					var oDate = new Date(col.defaultValue* 1000);
					multiEditorWindow[id].editControls[col.name + '_dateControl']
							.setValue(oDate);
					multiEditorWindow[id].editControls[col.name + '_hourControl']
							.setValue(oDate.getHours());
					multiEditorWindow[id].editControls[col.name + '_minuteControl']
							.setValue(oDate.getMinutes());
				}

			} else if (col.type == 'action') {
				var gridPanel = multiEditorWindow[id].editControls[col.name];
				gridPanel.getSelectionModel().deselectAll();
				gridPanel.getSelectionModel().clearSelections();
				gridPanel.getSelectionModel().position=null;
				var store = gridPanel.getStore();
				store.removeAll();
				store.add({
					'zoneID' : null,
					'groupID' : null,
					'sceneID' : null,
					'deltaTime' : 0
				});
			}
		}

		multiEditorWindow[id].show();

		return;
	}

}

// v2
function editItem(id) {
	if (id == null) {
		if (selectedItem == null)
			return;
		selectedId = selectedItem.get('id');
		editorWindow.show();
		setObjectData(selectedItem);
	} else {
		if (multiSelectedItem[id] == null)
			return;
		multiSelectedId[id] = multiSelectedItem[id].get('id');
		multiEditorWindow[id].show();
		setObjectData(multiSelectedItem[id], id);
	}
}

// v2
function enableItem(id) {
	if (id == null) {
		if (selectedItem == null)
			return;
		selectedItem.set('disabled', false);
		
		if (saveSingleCallback!=null)
			saveSingleCallback(getObjectDataFromSelection(),'disabled');
		else
			saveCallback(getObjectDataFromSelection());		
		
	} else {
		if (multiSelectedItem[id] == null)
			return;
		multiSelectedItem[id].set('disabled', false);

		if (saveSingleCallback!=null)
			saveSingleCallback(getObjectDataFromSelection(id),'disabled',id);
		else
			saveCallback(getObjectDataFromSelection(id),id);		

	}
}

// v2
function disableItem(id) {
	if (id == null) {
		if (selectedItem == null)
			return;
		selectedItem.set('disabled', true);
		if (saveSingleCallback!=null)
			saveSingleCallback(getObjectDataFromSelection(),'disabled');
		else
			saveCallback(getObjectDataFromSelection());		

	} else {
		if (multiSelectedItem[id] == null)
			return;
		multiSelectedItem[id].set('disabled', true);

		if (saveSingleCallback!=null)
			saveSingleCallback(getObjectDataFromSelection(id),'disabled',id);
		else
			saveCallback(getObjectDataFromSelection(id),id);		
	}
}

// v2
function deleteItem(id) {
	if (id == null) {
		if (selectedItem == null)
			return;
		deleteCallback(getObjectDataFromSelection());
	} else {
		if (multiSelectedItem[id] == null)
			return;
		deleteCallback(getObjectDataFromSelection(id), id);
	}
}

